<?php

require_once('Net/UserAgent/Mobile.php');

class Carrier {

public function mobile_carrier()
{

$type='';

	$agent = Net_UserAgent_Mobile::singleton();


	if($agent->isDoCoMo()){
		//DoCoMo
		$carrier = 'DOCOMO';
		//ブラウザタイプ
		$type = $agent->getHTMLVersion();

	} else if($agent->isEZweb()){
		//au
		$carrier = 'KDDI';

		if($agent->isWAP2()){
			//WAP2.0
			$type = 'wap2.0';
		}else{
			//HDML
			$type = 'hdml';
		}//end if
	}else if($agent->isSoftBank()){
		//SoftBank / Vodafone / J-PHONE
		$carrier = 'SB';

		if($agent->isTypeC()){
			//C型
			$type = 'c';
		}else if($agent->isTypeP()){
			//P型
			$type = 'p';
		}else if($agent->isTypeW()){
			//W型
			$type = 'w';
		}else if($agent->isType3GC()){
			//3GC型
			$type = '3gc';
		}//end if TYPE
	}else{
		//携帯以外の場合
		//$carrier = 'other';
		$carrier = 'DOCOMO';//for DEBUG

	}//end if 

	//機種名をチェック
	$model = $agent->getModel();


	//返り値
	$output = array($carrier,$model,$type);

	return $output;


}//end function

	/***
	 *    キャリアごとの入力モードのタグを返す
	 *
	***/
	public function data_type($carrier){
	
		switch($carrier[0]){
		case 'KDDI':
				$TAG=array('H'=>"format='*M'"
					  ,'K'=>"format='*M'"
					  ,'A'=>"format='*A'"
					  ,'N'=>"format='*N'"
					  ,'x'=>"format='*x'"
					  );
				break;
		case 'SB':
				$TAG=array('H'=>"mode='hiragana'"
					  ,'K'=>"mode='katakana'"
					  ,'A'=>"mode='alphabet'"
					  ,'N'=>"mode='numeric'"
					  );
				break;
		default:
				$TAG=array('H'=>"istyle='1'"
					  ,'K'=>"istyle='2'"
					  ,'A'=>"istyle='3'"
					  ,'N'=>"istyle='4'"
					  );
		}//end switch

		return($TAG);
	
	}//end function

}//end class
?>
