<?php
require_once 'Zend/View.php';
require_once 'Zend/Config/Ini.php';


require_once("Smarty/libs/Smarty.class.php");

class Smarty_View extends Zend_View_Abstract
{
    private $_smarty;
    
    public function __construct($module = '',$config = array())
    {
        parent::__construct($config);

        // Smartyライブラリの読み込み
        $this->_smarty = new Smarty;

//echo "-------{$module}--------<P>";
	if(!empty($module))
	{
        $this->_smarty->template_dir = CRAFT_APP."modules/{$module}/views";
        $this->_smarty->compile_dir = CRAFT_APP ."modules/{$module}/views_c";
	}else{
        $this->_smarty->template_dir = CRAFT_APP."views";
        $this->_smarty->compile_dir = CRAFT_APP ."views_c";
	}//end if
        $this->_smarty->config_dir = CRAFT_APP . "config";
        $this->_smarty->cache_dir = CRAFT_APP . "cache";
	 

   /* リクエストよりサイトのURLを求めセット
        $ctrl = Zend_Controller_Front::getInstance();
        $this->assign('url', $ctrl->getRequest()->getBaseUrl());
        // 設定ファイルよりタイトルセット
        $ini = new Zend_Config_Ini(CRAFT_APP . 'config/config.ini',
                                  'staging');
        $this->assign('title', $ini->site->title);
*/
    }

    public function assign($spec, $value = null)
    {
        $this->_smarty->assign($spec, $value);
    }

    public function showPage($template='template.tpl',$main = 'default',$carrier=null)
    {

        // main部のファイル名

				// キャリア指定がある場合は_K,_S,_D を付加する

				switch($carrier){
					case 'KDDI':
											$main= "K_{$main}";
			header("Content-Type:text/html; charset=SHIFT-JIS" );
											break;
					case 'SB':
											$main= "S_{$main}";
											break;
					case 'DOCOMO':
											$main= "D_{$main}";
			header("Content-Type:text/html; charset=SHIFT-JIS" );
											break;
					default:
			header("Content-Type:text/html; charset=SHIFT-JIS" );
											break;

				}//end switch


		//if($carrier != 'KDDI' &&  $carrier != 'SB' &&  $carrier != null  ){
		if($carrier == 'DOCOMO' || $carrier == 'KDDI'  ){
//echo "Smarty---Template----Carrier=PC-------->{$main}<P>";
				ob_start();

        $this->_smarty->assign("parts", $parts);
        // テンプレートの表示
        $this->_smarty->display($template);

				$str=ob_get_contents();
				$output = mb_convert_encoding($str,'SJIS',mb_internal_encoding());
				ob_end_clean();

				echo $output;

		}else{
//echo "Smarty---Template----Carrier=PC-------->{$main}<P>";
				ob_start();

        $this->_smarty->assign("main", $main);
        // テンプレートの表示
        $this->_smarty->display($template);

				$str=ob_get_contents();
				//$str = mb_convert_encoding($str,'UTF8','SJIS');
				ob_end_clean();
				$output = mb_convert_encoding($str,'SJIS','UTF8');
				echo $output;


		}//end if


    }

    protected function _run()
    {
        include func_get_arg(0);
    }
}
