<?php
require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Table.php';


require_once CRAFT_APP . 'models/DataBase.php';
require_once CRAFT_APP.'lib/Smarty/View.php';



class Backyard_IndexController extends Zend_Controller_Action 
{
public $module;
public $controller;

    /**
     * initアクション
     */
    public function init()
    {
		$req = $this->getRequest();

		$this->module     = $req->getModuleName();
		$this->controller = $req->getControllerName();

    }//end function

    /**
     * ビューにSmartyを使用するサンプル
     */
    public function indexAction()
    {

		$title = "メニュー";
		
		$pankuzu  = "メニュー";
		
		$view = new Smarty_View($this->module);
		$view->assign('title', $title);
		$view->assign("pankuzu", $pankuzu);
		$view->showPage('template.tpl','top_menu.tpl');
    }

    /**
     * スタッフ入力画面表示アクション
     */
    public function staffinputAction()
    {

       $param = Zend_Controller_Action::_getAllParams();
		
		$title = "担当者登録";
		
		$pankuzu = "担当者登録";
		
	//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("param", $param);
	$view->assign("title", $title);
	$view->assign("pankuzu", $pankuzu);
       $view->showPage('template.tpl','StaffInput.tpl');

    }

    /**
     * スタッフ入力画面表示アクション
     */
    public function staffconfAction()
    {

       $param = Zend_Controller_Action::_getAllParams();

				$param['STAFF_NAME'] = mb_convert_encoding($param['STAFF_NAME'],'UTF8','SJIS');
		
		$title = "担当者登録";
		
		$pankuzu = "担当者登録";
		
	//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("param", $param);
	$view->assign("title", $title);
	$view->assign("pankuzu", $pankuzu);
       $view->showPage('template.tpl','StaffConfirm.tpl');

    }

    /**
     * スタッフ登録
     */
    public function staffcompAction()
    {

       $param = Zend_Controller_Action::_getAllParams();
			
			if(!empty($param['STAFF_NAME'] )){
		 		$param['STAFF_NAME'] = mb_convert_encoding($param['STAFF_NAME'],'UTF8','SJIS');
			}//end if

		$title = "担当者登録";
		
		$pankuzu = "担当者登録";
		
	if(!empty($param['STAFF_NAME']))
	{
      // 担当者を登録
        $staff = new DbManager();

        $row = array (
		'STAFF_NAME'	=> $param['STAFF_NAME'],
		'REG_DATE'	=> date('Y/m/d H:i:s')
                 );
        $db = $staff->insert('staff_tbl',$row);


	$Message="";

	}else{

	$Message="担当者を入力してください";

	}//end if

	//Smartyに連想配列を渡す（assignする）
/*
	$view = new Smarty_View($this->module);
	$view->assign("Message", $Message);
	$view->assign("param", $param);
	$view->assign("title", $title);
	$view->assign("pankuzu", $pankuzu);
       $view->showPage('template.tpl','StaffComplete.tpl');
*/
			$this->_redirect('/backyard/index/stafflist/');


    }//end function


    public function stafflistAction()
    {
			
			  $param = Zend_Controller_Action::_getAllParams();

 			$staff = new DbManager();

				if(!empty($param['DISPLAY']) && $param['DISPLAY'] == 'ALL'){
					$sql="SELECT * FROM staff_tbl ";
					$list_display = 'ALL';

				}else{
					$sql="SELECT * FROM staff_tbl WHERE DEL_FLG != 1 ";
					$list_display = 'PARTS';
				}//end if

				$res = $staff->select($sql);


	//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);

		if( $res != -1 ){
			while( $row = mysql_fetch_array($res,MYSQL_ASSOC) ){
				$disp_data[]=$row;
			}//end while
				if(!empty($disp_data)){
		 			$view->assign("DISP_DATA", $disp_data);
				}//end if
	 }//end if

/*
echo '<PRE>';
var_dump($disp_data);
echo '</PRE>';
*/

				$view->assign("DISPLAY", $list_display);
				$view->assign("TITLE", "スタッフ一覧");
				//$view->assign("pankuzu", $pankuzu);
      	 $view->showPage('template.tpl','StaffList.tpl');

		}//end function

    public function staffupdateAction()
    {
			  $param = Zend_Controller_Action::_getAllParams();
		 	  $param['STAFF_NAME'] = mb_convert_encoding($param['STAFF_NAME'],'UTF8','SJIS');
		
		
			if(!empty($param['STAFF_NAME']))
			{
      // 担当者を更新
        $staff = new DbManager();

				if(!empty($param['DEL_FLG']) && $param['DEL_FLG'] != 0){
					$del_flg = $param['DEL_FLG'];
				}else{
					$del_flg = 0;
				}//end if

        $row = array (
					'STAFF_NAME'	=> $param['STAFF_NAME'],
					'DEL_FLG'			=> $del_flg,
					'REG_DATE'		=> date('Y/m/d H:i:s'),
					'REC_ID'				=> $param['REC_ID']
                 );

        $db = $staff->update('staff_tbl',$row);

			}//end if	

				$this->_redirect('/backyard/index/stafflist/');

		}//end function
    
    /**
     * アクション名が見つからない
     */
    public function __call($methodName, $args)
    {
        $param = Zend_Controller_Action::_getAllParams();
        $this->_redirect("/{$param['controller']}/");
    }
}
