<?php
require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Table.php';


require_once CRAFT_APP . 'models/DataBase.php';
require_once CRAFT_APP.'lib/Smarty/View.php';
class DB{
}

class IndexController extends Zend_Controller_Action 
{
public $module;
public $controller;
public $CARRIER=array();
public $Type_name;
public $Type_term;
public $Companion;

    /**
     * initアクション
     */
    public function init()
    {

require CRAFT_APP.'config/const.ini';

			$this->Type_name = $Type_name;
			$this->Type_term = $Type_term;
			$this->Companion = $Companion;

		$req = $this->getRequest();

		$this->module     = $req->getModuleName();
		$this->controller = $req->getControllerName();

/*
echo "KOKYAKU module------------>{$req->getModuleName()}<P>";
echo "ctrl------------>{$req->getControllerName()}<P>";
echo "action------------>{$req->getActionName()}<P>";
*/


    }

    /**
     * 初期メニューを表示する
     */
    public function indexAction()
    {
        $param = Zend_Controller_Action::_getAllParams();


				$view = new Smarty_View("kokyaku");

				$req = $this->getRequest();
				$view->assign("title","アスコットクラブ顧客管理システム");

        $view->showPage('template.tpl','menu.tpl');

    }//end function

    /**
     * 入力画面を表示する
     */
   public function inputAction()
    {

		$view = new Smarty_View('kokyaku');
		$view->assign("title","顧客情報入力画面");

/*
echo "<PRE>";
var_dump($Type);
echo "</pre>";
*/
		$checkbox = $this->checkbox_edit();
		$view->assign("COMPANION",$this->Companion);
		$view->assign("DISPLAY_CHECKBOX",$checkbox);
		$view->assign("back","BACK");
    $view->showPage('template.tpl','UserInput.tpl');

    }//end function

    /**
     * 確認画面を表示する
     */
   public function confirmAction()
    {

        $param = Zend_Controller_Action::_getAllParams();

				$param = $this->utf8_convert($param,'c_basic');
/*
echo "<PRE>";
var_dump($param);
echo "</pre>";
*/

				if(!empty($param['TYPE_TERM'])){
					$checkbox = $this->checkbox_edit($param['TYPE_TERM']);
				}else{
					$checkbox = $this->checkbox_edit();
				}//end if

				$view = new Smarty_View('kokyaku');
				if(!empty($param['UPDATE'])){
					$view->assign("title","顧客情報修正確認画面");
				}else{
					$view->assign("title","顧客情報入力確認画面");
				}//end if

				$view->assign("DISPLAY_CHECKBOX",$checkbox);

				$view->assign("COMPANION",$this->Companion);
				$view->assign("param",$param);
				$view->assign("back","BACK");
    		$view->showPage('template.tpl','UserInputConf.tpl');

    }//end function

    /**
     * DB登録後、完了画面を表示する
     */
   public function completeAction()
    {

        $param = Zend_Controller_Action::_getAllParams();


		/* フラグ　を　保存　する　*/
		$type_term = "";
		foreach($param['TYPE_TERM'] as $key1=>$TYPE){
		 foreach($TYPE as $key2=>$type){
				//echo "FLAG====>key1->{$key1}---key2->{$key2}====>{$type}<P>";
				$type_term .="{$key1},{$key2};"; 
			}//end foreach
		}//end foreach

		$row['TYPE_TERM'] = $type_term;

/*
echo "<PRE>";
var_dump($row);
echo "</pre>";
*/

		$db_term = $this->utf8_convert($param,'c_basic');

		$row['USER_NAME']     = $db_term['USER_NAME'];
		$row['NAME_FURIGANA'] = $db_term['NAME_FURIGANA'];
		$row['M_TEL_NO']      = $db_term['M_TEL_NO'];
		$row['PC_MAIL']       = $db_term['PC_MAIL'];
		$row['MOB_MAIL']      = $db_term['MOB_MAIL'];
		$row['ADDRESS']       = $db_term['ADDRESS'];
		$row['CAR']           = $db_term['CAR'] ;

		if(!empty($db_term['AZUKARI'])){
			$row['AZUKARI']        = $db_term['AZUKARI'] ;
		}//end if

		$row['TERM_3']        = $db_term['TERM_3'] ;
		$row['TERM_4']        = $db_term['TERM_4'] ;
		
  
/*
echo "<PRE>";
var_dump($row);
echo "</pre>";
*/

				/* 顧客基本情報登録　*/
       	//$c_basic = new C_BASIC();
       	$//db = $c_basic->getAdapter();
					$db = new DB();

				if( !empty($param['UPDATE'])){//更新
        	//$where = $db->quoteInto('REC_ID = ?', $param['UID']);
        	$key = $c_basic->update($row, $where);
				}else{//登録
  		  	
					$CREATE_TIME = date('Y/m/d H:i:s');
					$row['REG_DATE'] = $CREATE_TIME;
					$key=$c_basic->insert($row);

				}//end if

				/* 顧客ー＞コンパニオン情報　登録　*/
       	$c_log = new C_LOG();
       	$db = $c_log->getAdapter();

	


				if( !empty($param['UPDATE'])){//更新

				}else{//登録
				$log['USER_ID']  = $key;
				$log['REG_DATE'] = $param['TERM_1'];
				$log['GAL_ID']   = $param['TERM_2'];

  		  	$key=$c_log->insert($log);

				}//end if

				$checkbox = $this->checkbox_edit($param['TYPE_TERM']);

				$view = new Smarty_View('kokyaku');
				$view->assign("title","顧客情報入力完了画面");
				$view->assign("COMPANION",$this->Companion);
				$view->assign("DISPLAY_CHECKBOX",$checkbox);
				$view->assign("U_ID",$key);

				$view->assign("param",$db_term);
				$view->assign("back","BACK");
    		$view->showPage('template.tpl','UserInputComp.tpl');

    }//end function


    /**
     * ＣＨＥＣＫＢＯＸ表示編集
     */
	public function checkbox_edit($TYPE_TERM=null,$TYPE_TERMS=null) {

	$display="";

	foreach( $this->Type_name as $key1=>$type_name ){
		if( $key1 != 0 ){
			$display .= "<tr><td>{$type_name}</td><td>";

			foreach( $this->Type_term[$key1] as $key2=>$term ){
				if(!empty($TYPE_TERM[$key1][$key2])
						|| strstr($TYPE_TERMS,"{$key1},{$key2};")){
						$display .="<input type='checkbox' name='TYPE_TERM[{$key1}][{$key2}]' value='1' checked>{$term}\n";
					}else{
						$display .="<input type='checkbox' name='TYPE_TERM[{$key1}][{$key2}]' value='1'>{$term}\n";
					}//end if
		}//end foreach
					$display .="</td>";
		}//end if
	}//end foreach

  	return($display);

	}//end function


    /**
     *  FROM SJIS TO UTF8 文字コード変換
     */
	public function utf8_convert($param,$table) {
	require_once CRAFT_APP.'config/db_def.ini';

			foreach($$table as $key=>$db_term){
					if(!empty($param[$db_term])){
						$param[$db_term] = mb_convert_encoding($param[$db_term],'UTF8','SJIS');
					}//end if
			}//end foreach

			return($param);

		}//end function

    /**
     * 検索条件入力画面を表示する
     */
    public function searchcondAction()
    {

        $param = Zend_Controller_Action::_getAllParams();

				$view = new Smarty_View("kokyaku");

				$req = $this->getRequest();
				$view->assign("title","顧客情報検索");
				$view->assign("COMPANION",$this->Companion);
				$view->assign("back","BACK");
        $view->showPage('template.tpl','Search_Cond.tpl');

    }//end function

   /**
     * 検索結果一覧画面を表示する
     */
    public function searchAction()
    {
        $param = Zend_Controller_Action::_getAllParams();

				/*  検索　結果一覧表示　*/

  			$c_basic = new C_BASIC();
       	$db = $c_basic->getAdapter();
				
				/*  検索条件を組み立てる　*/
				$sql = $this->make_sql($param);

				$list= $db->fetchAll($sql);

				$view = new Smarty_View("kokyaku");

				$req = $this->getRequest();
				$view->assign("title","顧客情報検索　結果一覧");
				$view->assign("D_LIST",$list);
				$view->assign("back","BACK");
        $view->showPage('template.tpl','Search_List.tpl');

    }//end function

   /**
     * 検索詳細画面を表示する
     */
    public function detailAction()
    {
        $param = Zend_Controller_Action::_getAllParams();

				/*  検索　結果詳細画面表示　*/

  			$c_basic = new C_BASIC();
       	$db = $c_basic->getAdapter();
				$sql="SELECT * FROM C_BASIC WHERE REC_ID ={$param['id']}";
        //echo "{$sql}<br>";
				$row= $db->fetchAll($sql);

//echo "--->{$row[0]['TYPE_TERM']}<P>";
				$checkbox = $this->checkbox_edit(null,$row[0]['TYPE_TERM']);


				/* 顧客ー＞コンパニオン情報　検索　*/
       	$c_log = new C_LOG();
       	$db = $c_log->getAdapter();

				$sql="SELECT * FROM C_LOG WHERE USER_ID ={$param['id']}";
        //echo "{$sql}<br>";
				$log= $db->fetchAll($sql);


				$view = new Smarty_View("kokyaku");

				$req = $this->getRequest();
				$view->assign("title","顧客情報検索　詳細");
				$view->assign("ROW",$row);
				$view->assign("DISPLAY_CHECKBOX",$checkbox);
				$view->assign("LOG",$log);
				$view->assign("COMPANION",$this->Companion);
				$view->assign("back","BACK");
        $view->showPage('template.tpl','Search_Detail.tpl');

    }//end function


    /**
     * 検索条件から顧客検索用SQL を組み立てる
     */
	public function make_sql($param) {

			$select ="SELECT * FROM C_BASIC ";
			$where =" WHERE ";
			$flg = 0;

			if( !empty($param['REC_ID']) ){
						$where .= " REC_ID = {$param['REC_ID']} ";
						$flg = 1;
			}//end if

			$FURIGANA =mb_convert_encoding($param['NAME_FURIGANA'],'UTF8','SJIS');

			if( !empty($param['NAME_FURIGANA']) && $flg == 1 ){
						$where .= " AND NAME_FURIGANA like '%{$FURIGANA}%' ";
			}else{
					if(!empty($param['NAME_FURIGANA'])){
						$where .= " NAME_FURIGANA like '%{$FURIGANA}%' ";
							$flg = 1;
					}//end if
			}//end if		

			if( !empty($param['M_TEL_NO']) && $flg == 1 ){
						$where .= " AND M_TEL_NO like '%{$param['M_TEL_NO']}%' ";
			}else{
					if(!empty($param['M_TEL_NO'])){
							$where .= " M_TEL_NO like '%{$param['M_TEL_NO']}%' ";
							$flg = 1;
					}//end if
			}//end if		

			if( !empty($param['AZUKARI']) && $flg == 1 ){
						$where .= " AND AZUKARI = {$param['AZUKARI']} ";
			}else{
					if(!empty($param['AZUKARI'])){
							$where .= " AZUKARI = {$param['AZUKARI']} ";
							$flg = 1;
					}//end if
			}//end if	

		$TERM_3 =mb_convert_encoding($param['TERM_3'],'UTF8','SJIS');

			if( !empty($TERM_3) && $flg == 1 ){
						$where .= " AND TERM_3 like '%{$TERM_3}%' ";
			}else{
					if(!empty($param['TERM_3'])){
							$where .= " TERM_3 like '%{$TERM_3}%' ";
							$flg = 1;
					}//end if
			}//end if	

		$TERM_4 =mb_convert_encoding($param['TERM_4'],'UTF8','SJIS');

			if( !empty($TERM_4) && $flg == 1 ){
						$where .= " AND TERM_4 like '%{$TERM_4}%' ";
			}else{
					if(!empty($param['TERM_4'])){
							$where .= " TERM_4 like '%{$TERM_4}%' ";
							$flg = 1;
					}//end if
			}//end if	

			$sql = "{$select}{$where}";

			return($sql);
	}//end function


 /**
     * 検索詳細画面 で顧客履歴を追加する
     */
    public function addlogAction()
    {
        $param = Zend_Controller_Action::_getAllParams();

				if($param['TERM_2'] == 0 ){
					die("コンパニオンを入力してください");
				}//end if

			/* 顧客ー＞コンパニオン情報　登録　*/
       	$c_log = new C_LOG();
       	$db = $c_log->getAdapter();

				$log['USER_ID']  = $param['id'];
				$log['REG_DATE'] = $param['TERM_1'];
				$log['GAL_ID']   = $param['TERM_2'];

  		  $key=$c_log->insert($log);

				/*  詳細画面 */
				$this->_forward("detail");

			}//end function


   /**
     * コンパニオンからの検索結果一覧画面を表示する
     */
    public function search2Action()
    {
        $param = Zend_Controller_Action::_getAllParams();


				/* コンパニオンー＞顧客 情報　検索　*/
       	$c_log = new C_LOG();
       	$db = $c_log->getAdapter();

				$sql="SELECT C_BASIC.REC_ID,C_BASIC.NAME_FURIGANA,C_BASIC.M_TEL_NO,C_BASIC.AZUKARI 
				FROM C_LOG ,C_BASIC
				WHERE GAL_ID ={$param['TERM_2']}
							AND C_LOG.USER_ID = C_BASIC.REC_ID";

        //echo "{$sql}<br>";

				$list= $db->fetchAll($sql);

				$view = new Smarty_View("kokyaku");

				$req = $this->getRequest();
				$view->assign("title","顧客情報検索　結果一覧");
				$view->assign("D_LIST",$list);
				$view->assign("back","BACK");
        $view->showPage('template.tpl','Search_List.tpl');

    }//end function

   /**
     * 顧客情報修正画面を表示する
     */
    public function cmodifyAction()
    {
        $param = Zend_Controller_Action::_getAllParams();

				/*  検索　結果詳細画面表示　*/

  			$c_basic = new C_BASIC();
       	$db = $c_basic->getAdapter();
				$sql="SELECT * FROM C_BASIC WHERE REC_ID ={$param['id']}";
        //echo "{$sql}<br>";
				$row= $db->fetchAll($sql);

//echo "--->{$row[0]['TYPE_TERM']}<P>";
				$checkbox = $this->checkbox_edit(null,$row[0]['TYPE_TERM']);


				/* 顧客ー＞コンパニオン情報　検索　*/
/*
       	$c_log = new C_LOG();
       	$db = $c_log->getAdapter();

				$sql="SELECT * FROM C_LOG WHERE USER_ID ={$param['id']}";
        //echo "{$sql}<br>";
				$log= $db->fetchAll($sql);
*/

				$view = new Smarty_View("kokyaku");

				$req = $this->getRequest();
				$view->assign("title","顧客情報修正");
				$view->assign("UID",$param['id']);
				$view->assign("ROW",$row);
				$view->assign("DISPLAY_CHECKBOX",$checkbox);
				//$view->assign("LOG",$log);
				//$view->assign("COMPANION",$this->Companion);
				$view->assign("back","BACK");
        $view->showPage('template.tpl','UserUpdate.tpl');

    }//end function



    /**
     * 日付足し算
     */
	public function computeDate($addDays) {
	  $year =date('Y');
	  $month=date('m'); 
	  $day = date('d');

    		$baseSec = mktime(0, 0, 0, $month, $day, $year);//基準日を秒で取得
    		$addSec = $addDays * 86400;//日数×１日の秒数
    		$targetSec = $baseSec + $addSec;
    		return date("Y-m-d", $targetSec);
	}

     /**
     * 有効期間チェック
     */
	public function available_days($from,$to){

	$flg= TRUE;
/*
echo "time()----->".time()."<P>";
echo "from----->".strtotime($from)."<P>";
echo "to----->".strtotime($to)."<P>";
*/

	if(!empty($from) && !empty($to) ){//from to 両方ある
		if( (time() < strtotime($from) ) || ( strtotime($to) < time()  ) ){
			$flg = FALSE;
			//echo "ERROR----1<P>";
		}//end if
	}else if(!empty($from) ){//fromがある
		if( time() < strtotime($from) ){
			$flg = FALSE;
			//echo "ERROR----2<P>";
		}//end if
	}else if( !empty($to) ){//toがある
		if( strtotime($to) < time() ){
			$flg = FALSE;
			//echo "ERROR----3<P>";
		}//end if
	}else{
			//echo "OK----4<P>";
	}//end if

	if(!$flg){
         $view = new Smarty_View($this->module);
 

	 $view->assign("title", "ツアー選択エラー");
	 $view->assign("Message", "SELECT_ERROR");
	 $view->assign("CRRIER", $this->CARRIER[0]);

         $view->showPage('template.tpl','Message');
	die('');
	}//end if

	
	return($flg);
//die('===STOP===');

	}//end function


    /**
     * アクション名が見つからない
     */
    public function __call($methodName, $args)
    {
        $param = Zend_Controller_Action::_getAllParams();
die('===STOP===');
        //$this->_redirect("/{$param['controller']}/");
    }
}
