<?php
//２００９年１月８日　プログラムを見て怒らないでください
//清書する時間がありませんでした


require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Table.php';


require_once HIS_APP . 'models/Reserve.php';
require_once HIS_APP . 'models/Tour.php';
require_once HIS_APP.'lib/Smarty/View.php';
require_once HIS_APP.'lib/Mobile/Carrier.php';


class Front_ReserveController extends Zend_Controller_Action 
{
public $module;
public $controller;
public $table;
public $ERROR=array();
public $CARRIER=array();
public $DATA_TYPE=array();

    /**
     * initアクション
     */
    public function init()
    {
		$req = $this->getRequest();

		$this->module     = $req->getModuleName();
		$this->controller = $req->getControllerName();

		$carrier = new Carrier;

		$this->CARRIER = $carrier->mobile_carrier();

		$this->DATA_TYPE=$carrier->data_type($this->CARRIER);


/*
echo "module------------>{$req->getModuleName()}<P>";
echo "ctrl------------>{$req->getControllerName()}<P>";
echo "action------------>{$req->getActionName()}<P>";
*/
    }

    /**
     * デフォルトアクション
     */
    public function indexAction()
    {

        // パラメタを取得
       $param = Zend_Controller_Action::_getAllParams();

	//予約可能かどうかを確認
	//同行者含めた人数以上残席があること
	$diff = $this->bookable($param['S_ID'],0);

//echo "diff ===========>{$diff}<P>";

	if($diff < 0 ){
	//ツアー日程変更のためのパラメータ
	//エラー画面表示
        $view = new Smarty_View($this->module);
	$para = array(
			'T_ID'=>$param['T_ID']
			);
        $view->assign('param', $para);

	 $view->assign("title", "予約入力");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("ERROR", 'ERROR');

        $view->showPage('template.tpl','ReserveError');
	exit();
	}//end if

/*
echo "T_ID------------>{$param['T_ID']}<P>";
echo "S_ID------------>{$param['S_ID']}<P>";
*/

	//ここでR_IDがある場合は、日程変更(同行者人数も変更の可能性有）なので入力の画面に飛ぶ
	if(!empty($param['R_ID'])){
//echo "R_ID------------>{$param['R_ID']}<P>";
        	$rese = new Reserve();
        	$db = $rese->getAdapter();

	//日程変更
		$row['SCHEDULE_ID'] = $param['S_ID'];
        	$where = $db->quoteInto('RESERVE_ID = ?', $param['R_ID']);
		$rese->update($row, $where);

	//代表者修正画面を表示する
           	$this->_forward("./reservedisp");

	}else{

	//初めて表示する場合（R_IDがない）
	 $view = new Smarty_View($this->module);
	 $view->assign("param2", $param);
	//日程情報から人数のプルダウンを作成する
	 $hc=$this->head_count($param['S_ID']);
	 $view->assign("hc", $hc);

	 $view->assign("title", "予約入力(代表者情報入力)");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("DATA_TYPE", $this->DATA_TYPE);

         $view->showPage('template.tpl','ReserveInput');

	}//end if  R_ID がある場合


    }

    /**
     * 代表者情報insertアクション 
     */
    public function reserveinsertAction()
    {
         $param = Zend_Controller_Action::_getAllParams();

	//PARAM CHECK make row array
	$this->table='RESERVE';
	$row = $this->ParamCheck($param);
	$row['SCHEDULE_ID'] = $param['S_ID'];

	//エラーだったら入力画面を表示する
	if(!empty($this->ERROR)){
	//代表者入力画面を表示する
	 $view = new Smarty_View($this->module);
	 $view->assign("param2", $param);
	 $view->assign("param", $param);
	 $view->assign("error", $this->ERROR);
	//日程情報から人数のプルダウンを作成する
	 $hc=$this->head_count($param['S_ID']);
	 $view->assign("hc", $hc);

	 $view->assign("title", "予約入力(代表者情報入力)");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("DATA_TYPE", $this->DATA_TYPE);

         $view->showPage('template.tpl','ReserveInput');
	exit();
	}//end if

	 //既に登録されていたらUPDATE TEL_NO&SCHEDULE_ID
	//同じスケジュールに同じ電話番号のひとが申し込めないはず
	//（電話番号とﾒｰﾙｱﾄﾞﾚｽと誕生日が同じ場合）
        // 代表者を取得
        $rese = new Reserve();
        $db = $rese->getAdapter();
	$sql="SELECT RESERVE_ID FROM T_RESERVE WHERE SCHEDULE_ID={$param['S_ID']} AND TEL_NO={$param['TEL_NO']}
		AND EMAIL_ADDRESS='{$param['EMAIL_ADDRESS']}' AND BIRTHDAY={$param['BIRTHDAY']}";
//echo "SQL--->{$sql}<P>";
//die('===STOP===');
        $r_id = $db->fetchRow($sql);

//print_r($r_id);
//echo "<P>-->>>>>>>>>{$r_id['COUNT']}-<P>";


	if(!empty($r_id['RESERVE_ID'])){
        // 指定したidの行を更新

        $where = $db->quoteInto('RESERVE_ID = ?', $r_id['RESERVE_ID']);
	$rese->update($row, $where);
        $key = $r_id['RESERVE_ID'];
//echo "{$key}  が更新されました<P>";
	}else{
        // 行の挿入
        	$key=$rese->insert($row);
//echo "{$key}  が登録されました<P>";
	}//end if

//echo "{$param['controller']}<P>";

	//予約可能かどうかを確認
	//同行者含めた人数以上残席があること
	$param['COMPANION_MAX'] -=1;//代表者を引いて持ちまわるので小細工
	$diff = $this->bookable($param['S_ID'],$param['COMPANION_MAX']);

//echo "diff ===========>{$diff}<P>";

	if($diff < 0 ){
	//ツアー日程変更のためのパラメータ
	//エラー画面表示
       $view = new Smarty_View($this->module);
	$para = array(
			'R_ID'=>$key,
			'T_ID'=>$param['T_ID'],
			);
        $view->assign('param', $para);

	 $view->assign("title", "予約入力");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("ERROR", 'ERROR');

        $view->showPage('template.tpl','ReserveError');
	exit();
	}//end if

	//同行者1人以上の場合
	if( 1 < $row['COMPANION_MAX'])
	{
	$para = array(
			'R_ID'=>$key,
			'T_ID'=>$param['T_ID'],
			'S_ID'=>$param['S_ID'],
			'COMPANION_NO'=>1,
			'COMPANION_MAX'=>$row['COMPANION_MAX']-1
			);
//View 
        $view = new Smarty_View($this->module);

        $view->assign('param', $para);

	 $view->assign("title", "予約入力(同行者情報入力)");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("DATA_TYPE", $this->DATA_TYPE);

        $view->showPage('template.tpl','CompanionInput');

	}else{	//同行者０の場合
			$this->_setParam('R_ID',$key);
           		$this->_forward("allconfirm");
	}//end if

    }

   /**
     * 同行者情報insertアクション 
     */
    public function companioninsertAction()
    {
         $param = Zend_Controller_Action::_getAllParams();

	//同行者情報の登録
	 //CHECK & SET PARAM 
	$this->table='COMPANION';
	$row = $this->ParamCheck($param);
	$row['RESERVE_ID'] = $param['R_ID'];

	//エラーだったら入力画面を表示する
	if(!empty($this->ERROR)){
        $view = new Smarty_View($this->module);
        $view->assign('error', $this->ERROR);
        $view->assign('param', $param);

	 $view->assign("title", "予約入力(同行者情報入力)");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("DATA_TYPE", $this->DATA_TYPE);

        $view->showPage('template.tpl','CompanionInput');
	exit();
	}//end if
/*		
echo "<PRE>";
var_dump($row);
echo "</PRE>";
*/

	 //既に登録されていたらUPDATE TEL_NO&SCHEDULE_ID
	//同じ代表者IDに同じCOMPANION_NO番号のひとが申し込めないはず
        // 代表者を取得
        $comp = new Companion();
        $db = $comp->getAdapter();
	$sql="SELECT COMPANION_ID FROM T_RESERVE_COMPANION WHERE RESERVE_ID={$param['R_ID']} AND COMPANION_NO={$param['COMPANION_NO']}";
//echo "SQL--->{$sql}<P>";
        $c_id = $db->fetchRow($sql);

//print_r($row);
//echo "<P>-->>>>>>>>>{$c_id['COMPANION_ID']}-<P>";

	if(!empty($c_id['COMPANION_ID'])){
        // 指定したidの行を更新

        $where = $db->quoteInto('COMPANION_ID = ?', $c_id['COMPANION_ID']);
        $comp->update($row, $where);
//echo "更新されました<P>";
	}else{
        // 行の挿入


        $key=$comp->insert($row);
//echo "{$key}  が登録されました<P>";
	}//end if

//PARAMETER
	//予約可能かどうかを確認
	//同行者含めた人数以上残席があること
	$diff = $this->bookable($param['S_ID'],$param['COMPANION_MAX']);

//echo "diff ===========>{$diff}<P>";

	if($diff < 0 ){
	//予約不可能のためツアー日程変更
	//エラー画面表示
        $view = new Smarty_View($this->module);
	$para = array(
			'R_ID'=>$param['R_ID'],
			'T_ID'=>$param['T_ID'],
			);
        $view->assign('param', $para);

	 $view->assign("title", "予約入力");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("ERROR", 'ERROR');

        $view->showPage('template.tpl','ReserveError');
	exit();
	}else{
//予約可能　同行者の登録を継続する
	$para = array(
			'T_ID'=> $param['T_ID'],
			'S_ID'=> $param['S_ID'],
			'R_ID'=>$param['R_ID'],
			'COMPANION_NO'=>$param['COMPANION_NO']+1,
			'COMPANION_MAX'=>$param['COMPANION_MAX']
			);
//View 
        $view = new Smarty_View($this->module);

        $view->assign('param', $para);
		if( $row['COMPANION_NO'] != $param['COMPANION_MAX']){

	 		$view->assign("title", "予約入力(同行者情報入力)");
	 		$view->assign("CRRIER", $this->CARRIER[0]);
	 		$view->assign("DATA_TYPE", $this->DATA_TYPE);

        		$view->showPage('template.tpl','CompanionInput');
		}else{
           		$this->_forward("allconfirm");
			
		}//end if
	}//end if

    }
 
  /**
     * データ確認画面表示
     */
    public function allconfirmAction()
    {
 
 //パラメタを受け取る

        $param = Zend_Controller_Action::_getAllParams();

//echo "<P>ALL CONFIRM COMPANION_MAX={$param['COMPANION_MAX']}<P>";

        // 代表者を取得
        $rese = new Reserve();
        $db = $rese->getAdapter();

//echo "<P>ALL CONFIRM R_ID={$param['R_ID']}<P>";

        $where = $db->quoteInto('RESERVE_ID = ?', $param['R_ID']);
        $row1 = $rese->fetchRow($where)->toArray();

	//ﾂｱｰ情報を取得

        $tour = new Tour();
        $db_t = $tour->getAdapter();

	$sql_t="SELECT * FROM M_TOURPACKAGE WHERE TOUR_ID={$row1['TOUR_ID']}";
//echo "SQL====>{$sql_t}<P>";

        $row_t = $db_t->fetchRow($sql_t);

	$sql_s="SELECT SCHEDULE_DATE FROM M_TOURPACKAGE_SCHEDULE WHERE SCHEDULE_ID={$row1['SCHEDULE_ID']}";
//echo "SQL====>{$sql_s}<P>";

        $row_s = $db_t->fetchRow($sql_s);

	$tour_info=array(
			'TOUR_CODE'=>$row_t['TOUR_CODE'],
			'TOUR_NAME'=>$row_t['TOUR_NAME'],
			'TOUR_URL'=> $row_t['TOUR_URL'],
			'SCHEDULE_DATE'=>$row_s['SCHEDULE_DATE']
			);

		
        // 同行者を取得
        $comp = new Companion();
        $db = $comp->getAdapter();
        $where = $db->quoteInto('RESERVE_ID = ?', $param['R_ID']);
        $row2 = $comp->fetchAll($where)->toArray();

//View 
        $view = new Smarty_View($this->module);
//echo "<P>ALL CONFIRM row2 COMPANION_MAX={$row1['COMPANION_MAX']}<P>";

	$row1['COMPANION_MAX']=$row1['COMPANION_MAX']-1;
  	$view->assign("param0", $tour_info);
  	$view->assign("param1", $row1);
  	$view->assign("param2", $row2);

	 $view->assign("title", "入力内容確認画面");
	 $view->assign("CRRIER", $this->CARRIER[0]);

        $view->showPage('template.tpl','ReserveConfirm');


    }

    /**
     * 予約完了アクション
     */
    public function reservecompleteAction()
    {
        $param = Zend_Controller_Action::_getAllParams();

	//既に予約完了しているかをチェックする
	//予約完了していたら予約済み画面を表示して終了
	$this->reserved($param);


	//予約可能かどうかを確認
	//同行者含めた人数以上残席があること
	$diff = $this->bookable($param['S_ID'],$param['COMPANION_MAX']);

echo "diff ===========>{$diff}<P>";
//die('===STOP===');
	if($diff < 0 ){
	//予約不可能のためツアー日程変更
	//エラー画面表示
        $view = new Smarty_View($this->module);
	$para = array(
			'R_ID'=>$param['R_ID'],
			'T_ID'=>$param['T_ID'],
			);
        $view->assign('param', $para);

	 $view->assign("title", "予約入力");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("ERROR", 'ERROR');

        $view->showPage('template.tpl','ReserveError');
	exit();
	}//end if

        // ツアー募集人数を更新
	//diff >= 0 のときは募集人員をマイナス
	// TRUNSACTION START
        $row = array (
		'SCHEDULE_HEADCOUNT'	=> $diff
                 );
      	 $tour = new Tour_Schedule();
        $db = $tour->getAdapter();
        $where = $db->quoteInto('SCHEDULE_ID = ?', $param['S_ID']);
        $key = $tour->update($row, $where);
	//ツアー情報の更新　ここまで

        // 代表者のSTATUSを「予約済」に更新
	$config = new Zend_Config_Ini(HIS_APP .'config/config.ini', 'production');
	$status =$config->status->reserve;

        $rese = new Reserve();
        $row = array (
		'STATUS'	=>$status,
		'UPDATE_TIME'	=> date('Y/m/d H:i:s')
                 );
        $db = $rese->getAdapter();
        $where = $db->quoteInto('RESERVE_ID = ?', $param['R_ID']);
        $key = $rese->update($row, $where);

	// TRUNSACTION END
	//予約完了

	//予約完了　メール送信

	$From ="murofushi_t@mobilecommerce.co.jp";//configに定義
	$To = $param['toMail'];
	$Subject ="HIS 予約受付";

	$data=array();
        $data = $rese->fetchRow($where)->toArray();


	//require_once 'ReserveConfMail.tpl';
	if($data['SEX'] != 2)
	{
		$SEX='男性';
	}else{
		$SEX='女性';
	}//end if
$Body="
{$data['NAME_SEI']} {$data['NAME_MEI']}様\n
\n
このたびは「{$param['TOUR_NAME']}」をご予約いただき誠にありがとうございます。\n

ご予約いただいた内容をお知らせいたします。\n
\n
ﾂｱｰｺｰﾄﾞ：{$param['TOUR_CODE']}\n
ﾂｰｱ名：{$param['TOUR_NAME']}\n
{$param['TOUR_URL']}\n
出発日：{$param['SCHEDULE_DATE']}\n
お名前：{$data['NAME_SEI']} {$data['NAME_MEI']}\n
お名前（ｱﾙﾌｧﾍﾞｯﾄ）：  {$data['NAME_MEI_ALP']} {$data['NAME_SEI_ALP']}\n
ﾒｰﾙｱﾄﾞﾚｽ:{$data['EMAIL_ADDRESS']}\n
生年月日：{$data['BIRTHDAY']}\n
性別：{$SEX}\n
電話番号：{$data['TEL_NO']}\n
住所：{$data['ADDRESS1']}{$data['ADDRESS2']}{$data['ADDRESS3']}\n
\n
人数：{$data['COMPANION_MAX']}人\n

ご予約いただきました内容につきましては、後ほどｺｰﾙｾﾝﾀｰより
確認のご連絡をさせていただきます。\n

";

//echo "メール本文　返還前----><P>{$Body}<P>";

	//文字コード設定
	//$mailCharset='ISO-2022-JP';
	$mailCharset='shift-jis';	
	$crrCharset='utf-8';
	$Subject  = mb_convert_encoding($Subject, $mailCharset ,$crrCharset);
	$Body     = mb_convert_encoding($Body, $mailCharset ,$crrCharset);
//echo "メール本文　AFTER----><P>{$Body}<P>";

	$this->mail_send($From,$To,$Subject,$Body);
//View 
         $view = new Smarty_View($this->module);
  	 $view->assign("param", $param);

	 $view->assign("title", "予約完了");
	 $view->assign("CRRIER", $this->CARRIER[0]);

         $view->showPage('template.tpl','ReserveComplete');

    }

   /**
     * 代表者修正　のための表示アクション
     */
    public function reservedispAction()
    {

        // パラメータ取得
        $param = Zend_Controller_Action::_getAllParams();

//echo "R_ID------------>{$param['R_ID']}<P>";

        $rese = new Reserve();
     	$db = $rese->getAdapter();
        $where = $db->quoteInto('RESERVE_ID = ?', $param['R_ID']);
        $row = $rese->fetchRow($where)->toArray();
	  if(empty($param['UPDATE'])){
		$param['UPDATE']='RE_RESERVE';
	  }//end if
	 	$param2=array(
			'T_ID'=>$param['T_ID'],
			'S_ID'=>$row['SCHEDULE_ID'],
			'R_ID'=>$param['R_ID'],
			'UPDATE'=>$param['UPDATE']
			);


//Smartyに連想配列を渡す（assignする）
	 $view = new Smarty_View($this->module);

	 //同行者数から１を引く
	 $row['COMPANION_MAX'] = $row['COMPANION_MAX']-1;


	 $view->assign("param", $row);
	 $view->assign("param2", $param2);
/*
	//日程情報から人数のプルダウンを作成する
	 $hc=$this->head_count($param['S_ID']);
*/

	 $view->assign("title", "予約更新(代表者情報更新)");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("DATA_TYPE", $this->DATA_TYPE);

         $view->showPage('template.tpl','ReserveInput');


    }


    /**
     * 代表者予約更新アクション
     */
    public function reserveupdateAction()
    {
        $param = Zend_Controller_Action::_getAllParams();

	//予約可能かどうかを確認
	//同行者含めた人数以上残席があること
	$C_MAX = $param['COMPANION_MAX'] +1 ;
	$diff = $this->bookable($param['S_ID'],$C_MAX);

//echo "diff ===========>{$diff}<P>";

	if($diff < 0 ){
	//予約不可能のためツアー日程変更
	//エラー画面表示
        $view = new Smarty_View($this->module);
	$para = array(
			'R_ID'=>$param['R_ID'],
			'T_ID'=>$param['T_ID'],
			);
        $view->assign('param', $para);

	 $view->assign("title", "予約入力");
	 $view->assign("CRRIER", $this->CARRIER[0]);

        $view->showPage('template.tpl','ReserveError');
	exit();
	}//end if


	//入力チェック＆パラメータセット
	$this->table = 'RESERVE';
	$row = $this->ParamCheck($param,'UPDATE');

/*
echo "RESERVE UPDATE ------>><PRE>";
var_dump($param);
echo "--------RESERVE UPDATE</PRE>";
*/
	//同行者数を元に戻す
	$row['COMPANION_MAX'] = $C_MAX;


	//エラーだったら入力画面を表示する
	if(!empty($this->ERROR)){
	//代表者入力画面を表示する
	 $view = new Smarty_View($this->module);
	 $param['UPDATE']='UPDATE';
	 $view->assign("param2", $param);
	 $view->assign("param", $param);
	 $view->assign("error", $this->ERROR);
/*
	//日程情報から人数のプルダウンを作成する
	 $hc=$this->head_count($param['S_ID']);
	 $view->assign("hc", $hc);
*/

	 $view->assign("title", "予約更新(代表者情報更新)");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("DATA_TYPE", $this->DATA_TYPE);

         $view->showPage('template.tpl','ReserveInput');
	exit();
	}//end if


        $rese = new Reserve();
        $db = $rese->getAdapter();
        $where = $db->quoteInto('RESERVE_ID = ?', $param['R_ID']);
        $key = $rese->update($row, $where);
//View 
	//同行者を何人入力してあるかをチェックする
        $comp = new Companion();
     	 $db = $comp->getAdapter();
	 $sql="SELECT COUNT(*) FROM T_RESERVE_COMPANION WHERE RESERVE_ID={$param['R_ID']}";
//echo "SQL--->{$sql}<P>";
        $count = $db->fetchOne($sql);

//echo "<P>-->>>>>>>>>{$count}<P>";


//echo "<P>COMPANION_MAX={$param['COMPANION_MAX']}<P>";

	//同行者をまだ入力していない場合($count=0)
	if( $count < $param['COMPANION_MAX'] ){
	$para = array(
			'T_ID'=>$param['T_ID'],
			'R_ID'=>$param['R_ID'],
			'S_ID'=>$param['S_ID'],
			'COMPANION_NO'=>$count + 1,
			'COMPANION_MAX'=>$row['COMPANION_MAX']-1
			);
//View 
        $view = new Smarty_View($this->module);

        $view->assign('param', $para);

	 $view->assign("title", "予約入力(同行者情報入力)");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("DATA_TYPE", $this->DATA_TYPE);

        $view->showPage('template.tpl','CompanionInput');


	}else{

	//すべて入力済みの場合は確認画面に飛ぶ
           $this->_forward("./allconfirm");
	}//end if

    }


   /**
     * 同行者修正　のための表示アクション
     */
    public function companiondispAction()
    {

        // パラメータ取得
       $param = Zend_Controller_Action::_getAllParams();

/*
echo "R_ID------------>{$param['R_ID']}<P>";
echo "C_ID------------>{$param['C_ID']}<P>";
echo "C_MAX------------>{$param['COMPANION_MAX']}<P>";
*/

	$view = new Smarty_View($this->module);

        $comp = new Companion();
     	$db = $comp->getAdapter();
        $where = $db->quoteInto('COMPANION_ID = ?', $param['C_ID']);
        $row = $comp->fetchRow($where)->toArray();
//echo "C_MAX-------XXXX----->{$param['COMPANION_MAX']}<P>";
	$param2=array(	'R_ID'=>$param['R_ID'],
			'C_ID'=>$param['C_ID'],
			'COMPANION_MAX'=>$param['COMPANION_MAX'],
			'UPDATE'=>'UPDATE'
			);
//Smartyに連想配列を渡す（assignする）
	$view->assign("param", $row);
	$view->assign("param2", $param2);

	 $view->assign("title", "予約更新(同行者情報更新)");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("DATA_TYPE", $this->DATA_TYPE);

        $view->showPage('template.tpl','CompanionInput');


    }


    /**
     * 同行者情報更新アクション
     */
    public function companionupdateAction()
    {
        $param = Zend_Controller_Action::_getAllParams();
        // 指定したidの行を更新
        $comp = new Companion();
//echo "C_ID------------>{$param['C_ID']}<P>";
	//入力チェック＆パラメータセット
	$this->table = 'COMPANION';
	$row = $this->ParamCheck($param,'UPDATE');

	//エラーだったら入力画面を表示する
	if(!empty($this->ERROR)){
        $view = new Smarty_View($this->module);
        $view->assign('error', $this->ERROR);
	$param2=array(
			'R_ID'=>$param['R_ID'],
			'C_ID'=>$param['C_ID'],
			'COMPANION_MAX'=>$param['COMPANION_MAX'],
			'UPDATE'=>'UPDATE'
			);
        $view->assign('param2', $param2);
        $view->assign('param', $param);

	 $view->assign("title", "予約更新(同行者情報更新)");
	 $view->assign("CRRIER", $this->CARRIER[0]);
	 $view->assign("DATA_TYPE", $this->DATA_TYPE);

        $view->showPage('template.tpl','CompanionInput');
	exit();
	}//end if

/*
echo "<PRE>";
var_dump($row);
echo "</PRE>";
*/
        $db = $comp->getAdapter();
        $where = $db->quoteInto('COMPANION_ID = ?', $param['C_ID']);
        $key = $comp->update($row, $where);
//View 
           $this->_forward("./allconfirm");

    }



    /**
     *   入力チェック insertのときはパラメータなし
     * 			　updateのときは$act='UPDATE'
     */
    public function ParamCheck($param,$act="")
    {
require_once HIS_APP.'lib/ErrorMessages.php';

	if(!empty($param['NAME_SEI'])){
		$row['NAME_SEI'] 	= htmlspecialchars($param['NAME_SEI']);
	}else{
		$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_SEI];
	}//end if

	if(!empty($param['NAME_MEI'])){
		$row['NAME_MEI']	= htmlspecialchars($param['NAME_MEI']);
	}else{
		$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_MEI];
	}//end if


	if(!$this->eisuzi($param['NAME_SEI_ALP'])){
		$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_SEI_ALP];
	}elseif(empty($param['NAME_SEI_ALP'])){
		$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_SEI_ALP];
	}else{
		$row['NAME_SEI_ALP']	= htmlspecialchars($param['NAME_SEI_ALP']);
	}//end if


	if(!$this->eisuzi($param['NAME_MEI_ALP'])){
		$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_MEI_ALP];
	}elseif(empty($param['NAME_MEI_ALP'])){
		$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_MEI_ALP];
	}else{
		$row['NAME_MEI_ALP']	= htmlspecialchars($param['NAME_MEI_ALP']);
	}//end if

$yy=intval(substr($param['BIRTHDAY'],0,4));
$mm=intval(substr($param['BIRTHDAY'],4,2));
$dd=intval(substr($param['BIRTHDAY'],6,2));

	if(!$this->suzi($param['BIRTHDAY'])){
		$this->ERROR[]=$ERROR_MESSAGE[ER_BIRTHDAY];
	}elseif(empty($param['BIRTHDAY'])){
		$this->ERROR[]=$ERROR_MESSAGE[ER_BIRTHDAY];
	}elseif(checkdate($mm,$dd,$yy) != TRUE){
		$this->ERROR[]=$ERROR_MESSAGE[ER_BIRTHDAY];
	}else{
		$row['BIRTHDAY'] = htmlspecialchars($param['BIRTHDAY']);
	}//end if

	if(!empty($param['SEX'])){
		$row['SEX']	= htmlspecialchars($param['SEX']);
	}else{
		$this->ERROR[]=$ERROR_MESSAGE[ER_SEX];
	}//end if

if( $this->table == 'RESERVE'){
//echo "-----------{$this->table}<P>";

	if(!empty($param['T_ID'])){
		$row['TOUR_ID']	= htmlspecialchars($param['T_ID']);
	}else if(!empty($param['TOUR_ID'])){
		$row['TOUR_ID']	= htmlspecialchars($param['TOUR_ID']);
	}//end if

	if(!$this->email_check($param['EMAIL_ADDRESS'])){
		$this->ERROR[]=$ERROR_MESSAGE[ER_MAIL];
	}elseif(empty($param['EMAIL_ADDRESS'])){
		$this->ERROR[]=$ERROR_MESSAGE[ER_MAIL];
	}else{
		$row['EMAIL_ADDRESS']	= htmlspecialchars($param['EMAIL_ADDRESS']);
	}//end if

	if(!$this->suzi($param['TEL_NO'])){
		$this->ERROR[]=$ERROR_MESSAGE[ER_TEL_NO];
	}elseif(empty($param['TEL_NO'])){
		$this->ERROR[]=$ERROR_MESSAGE[ER_TEL_NO];
	}else{
		$row['TEL_NO']		= htmlspecialchars($param['TEL_NO']);
	}//end if

	if(!empty($param['ADDRESS1'])){
		$row['ADDRESS1']		= htmlspecialchars($param['ADDRESS1']);
	}//end if

	if(!empty($param['ADDRESS2'])){
		$row['ADDRESS2']		= htmlspecialchars($param['ADDRESS2']);
	}//end if

	if(!empty($param['ADDRESS3'])){
		$row['ADDRESS3']		= htmlspecialchars($param['ADDRESS3']);
	}//end if

	if(!empty($param['COMPANION_MAX']) OR $param['COMPANION_MAX'] == 0){
		$row['COMPANION_MAX']	= htmlspecialchars($param['COMPANION_MAX']);
	}//end if

}else{//$table=COMPANION

	if(!empty($param['COMPANION_NO'])){
		$row['COMPANION_NO']		= htmlspecialchars($param['COMPANION_NO']);
	}//end if

}//end if 

	if(!empty($act)){
		$row['UPDATE_TIME']= date('Y/m/d H:i:s');
	}else{
		$row['CREATE_TIME']= date('Y/m/d H:i:s');
	}//end if

	return $row;

     }//end function


    /**
     * メール送信　ざっくり！
     * 			
     */

	function mail_send($From,$To,$Subject,$Body){

	require_once "Mail.php";

	$params = array(
  	'host' => 'smtp.mobilecommerce.co.jp',
  	'port' => '587',
  	'auth' => false,
  	'username' => 'murofushi_t@mobilecommerce.co.jp',
  	'password' => '200806051',
	);


	$recipients = $To;

	$headers['From']    = $From;
	$headers['To']      = $To;
	$headers['Subject'] = $Subject;

	$body = $Body;

	$objMail =& Mail::factory('smtp', $params);
	$result = $objMail->send($recipients, $headers, $body);
	if (PEAR::isError($result)) {
	//echo "メール送信NG!!";
  		return -1;
	}else{
	//echo "メール送信OK!!";
		return 1;
	}

	}//end function


    /**
     * 予約可能か否かのチェック
     * ツアー募集人数と同行者の人数の差を返す
     */
    public function bookable($s_id,$comp_max){

        $sche = new Tour_Schedule();
        $db = $sche->getAdapter();

	$sql="SELECT SCHEDULE_HEADCOUNT FROM M_TOURPACKAGE_SCHEDULE WHERE SCHEDULE_ID={$s_id}";
//echo "SQL--->{$sql}<P>";
        $h_cnt = $db->fetchRow($sql);

//echo "<P>-->>>>>>>>>{$h_cnt['SCHEDULE_HEADCOUNT']}-<P>";
	
	//募集人数から人数を差し引く
	if($comp_max != 0){
		$diff= $h_cnt['SCHEDULE_HEADCOUNT']-$comp_max;
	}else{
		$diff= $h_cnt['SCHEDULE_HEADCOUNT'];
	}//end if

	return($diff);

    }//end function


    /**
     * 人数プルダウンの作成
     * プルダウンに表示する人数を返す
     */
    public function head_count($s_id){

        $sche = new Tour_Schedule();
        $db = $sche->getAdapter();

	$sql="SELECT * FROM M_TOURPACKAGE_SCHEDULE WHERE SCHEDULE_ID={$s_id}";
//echo "SQL====>{$sql}<P>";
        $row = $db->fetchRow($sql);

//echo "{$row['SCHEDULE_HEADCOUNT']}<P>";

	if(empty($row['SCHEDULE_MINI'])){
		$row['SCHEDULE_MINI'] = 1;
	}//end if

	if(empty($row['SCHEDULE_MAX'])){
		$row['SCHEDULE_MAX'] = 1;
	}//end if
		

	//最小人数から最大人数まで
	for($i=$row['SCHEDULE_MINI'];$i<=$row['SCHEDULE_MAX'];$i++){	
            if( $row['SCHEDULE_THREE'] && $i == 3 ){
	    }else if( $row['SCHEDULE_FIVE'] && $i == 5 ){
  	    }else if( $row['SCHEDULE_ODD'] && 6 < $i &&($i%2) == 1 ){
  	    }else if( $row['SCHEDULE_HEADCOUNT'] <= $i ){
		$hc[$i] = $i;
		break;
	    }else{	
		$hc[$i] = $i;
	    }//end if

	}//end for

	if(empty($hc)){
		$hc[0]=1;
	}//end if

	return($hc);

    }//end function


    /**
     * 英数字チェック
     */
	public function eisuzi($string){

	if (preg_match("/^[a-zA-Z0-9]+$/", $string)) {
		return 1;
	}
	else{
		return 0;
	}//end if

	}

    /**
     * 数字チェック
     */
	public function suzi($string){

	if (preg_match("/^[0-9]+$/", $string)) {
		return 1;
	}else{
		return 0;
	}//end if
	}

    /**
     * メールアドレスチェック
     */
	public function email_check($mailaddress){

	if (preg_match('/^[a-zA-Z0-9_\.\-]+@[A-Za-z0-9]+(\.[A-Za-z0-9]+)+$/',$mailaddress))
	{
		return 1;
	}
	else{
		return 0;
	}//end if

	}


    /**
     * 予約済みチェック 
     * 予約済みの場合は予約完了画面を表示する
     */
	public function reserved($param){

        // 代表者を取得
        $rese = new Reserve();
        $db = $rese->getAdapter();

//echo "<P>ALL CONFIRM R_ID={$param['R_ID']}<P>";

        $where = $db->quoteInto('RESERVE_ID = ?', $param['R_ID']);
        $row = $rese->fetchRow($where)->toArray();
/*
echo "<PRE>";
var_dump($row);
echo "</PRE>";
*/
	$config = new Zend_Config_Ini(HIS_APP .'config/config.ini', 'production');
	$status =$config->status->reserve;

	if($status != $row['STATUS']){
		return(TRUE);
	}//end if

	//View 
         $view = new Smarty_View($this->module);
  	 $view->assign("param", $param);

	 $view->assign("title", "予約完了済み");
	 $view->assign("Message", "RESERVED");
	 $view->assign("CRRIER", $this->CARRIER[0]);

         $view->showPage('template.tpl','Message');


	die('');
	}//end function



    /**
     * アクション名が見つからない
     */
    public function __call($methodName, $args)
    {
        header('HTTP/1.1 404 Not found');
	throw new Exception('例外です');
        $view = new My_View();
        $view->pageTitle = '404 Not found';
        $view->content = '指定ページが見つかりません';
        $view->showPage();
    }

}

