<?php
//２００９年１月８日　プログラムを見て怒らないでください
//清書する時間がありませんでした


require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Table.php';


require_once HIS_APP . 'models/Reserve.php';
require_once HIS_APP . 'models/Tour.php';
require_once HIS_APP . 'models/System.php';
require_once HIS_APP.'lib/Smarty/View.php';
require_once HIS_APP.'lib/Mobile/Carrier.php';
require_once HIS_APP.'lib/Mail/qdmail.php';


class Front_ReserveController extends Zend_Controller_Action 
{
public $module;
public $controller;
public $table;
public $diff;
public $param=array();
public $sess_id;
public $sess_data=array();
public $C_NO;
public $C_BEFORE;
public $C_NEXT;
public $base_url;
public $top_url;

public $ERROR=array();
public $CARRIER=array();
public $DATA_TYPE=array();


    /**
     * initアクション
     */
    public function init()
    {
		$req = $this->getRequest();

		$this->module     = $req->getModuleName();
		$this->controller = $req->getControllerName();

/************************/
		$carrier = new Carrier;

		$this->CARRIER = $carrier->mobile_carrier();

		$this->DATA_TYPE=$carrier->data_type($this->CARRIER);


/*
echo "CARRIER carrier------------>{$this->CARRIER[0]}<P>";
echo "module------------>{$req->getModuleName()}<P>";
echo "ctrl------------>{$req->getControllerName()}<P>";
echo "action------------>{$req->getActionName()}<P>";
*/


/************************/
	//全パラメータを取得
       $this->param = Zend_Controller_Action::_getAllParams();

	//BASE_URL 取得
				$config = new Zend_Config_Ini(HIS_APP .'config/config.ini', 'production');
				$this->base_url =	$config->site->url;//configに定義
				$this->top_url  =	$config->top->url;//configに定義

$this->R_debug($this->base_url,'55:---BASE_URL---',0,0);//1:stop 0:go 
$this->R_debug($this->top_url,'55:---TOP_URL---',0,0);//1:stop 0:go 

	//セション情報を取得
	if(!empty($this->param['SESS_ID'])){//更新か日付変更

		//セッション情報をDBから取得
		$this->sess_data = $this->sess_db_get($this->param['SESS_ID']);

		//同行者を何人入力したか？
		if( !empty($this->sess_data['COMPANION']) ){
			$this->sess_data['C_INPUT'] = count($this->sess_data['COMPANION'])-1;
		}else{
			$this->sess_data['C_INPUT'] = 0;
		}//end if

$this->R_debug($this->sess_data,'---SESS_FRO DB---',0,0);//1:stop 0:go

$this->R_debug($this->sess_data['C_INPUT'],'---COMPANION COUNT---',0,0);//1:stop 0:go

		$this->sess_data['SESS_ID'] = $this->param['SESS_ID'];

	    if(!empty($this->param['S_CHANGE'])){//日付変更

			//ツアー情報・日程情報のセット
			$this->sess_tour_set();

			//
			$this->sess_data['S_ID'] = $this->param['S_ID'];

	    }//end if

$this->R_debug($this->param,'-----日程変更 ------',1,0);//1:stop 0:go

	//予約可能かどうかを確認
	//同行者含めた人数以上残席があること
	if(!empty($this->sess_data['RESERVE']['COMPANION_MAX'])){
		
			if(!empty($this->param['S_ID'])){
					$S_ID = $this->param['S_ID'];
			}else{
					$S_ID = $this->sess_data['S_ID'];
			}//end if

			$this->diff = $this->bookable($S_ID,$this->sess_data['RESERVE']['COMPANION_MAX']);

	}else{
		$this->diff = $this->bookable($this->sess_data['S_ID'],0);
	}//end if

	//$this->R_debug($this->diff,'-----予約可能? ------',0,0);//1:stop 0:go

	}else{//最初のアクセス

	//ツアー情報・日程情報のセット
	$this->sess_tour_set();

	//パラメータ初期値のセット

	$this->sess_data['T_ID'] = $this->param['T_ID'];
	$this->sess_data['S_ID'] = $this->param['S_ID'];


	$this->sess_data['disp_mode'] = 'INSERT';

	$this->sess_data['C_MAX'] = 0;

	// 日程変更
	$this->sess_data['S_CHANGE'] = 0;


	//予約可能かどうかを確認
	//同行者含めた人数以上残席があること
	$this->diff = $this->bookable($this->param['S_ID'],1);


	}//end if

	if($this->diff < 0 ){
		$this->_forward("noreserve");
	}//end if

			if(empty($this->param['C_NO'])){
				$this->param['C_NO'] = 0;
			}//end if



    }//end function init

/*************************制御系関数　ここから*******************************/
    /**
     * ツアー情報・日程情報のセット
     */
    public function sess_tour_set(){
		//ツアー情報の取得
        $tour = new Tour();
        $db = $tour->getAdapter();
        $sql="SELECT TOUR_ID,TOUR_CODE,TOUR_NAME,TOUR_URL 
				FROM M_TOURPACKAGE 
              WHERE TOUR_ID={$this->param['T_ID']}";
//echo "SQL--->{$sql}<P>";
        $row_t = $db->fetchRow($sql);

		//セッションデータにセット
		 $this->sess_set('TOUR',$row_t);

		//日程情報の取得
        $sql="SELECT * FROM M_TOURPACKAGE_SCHEDULE 
				WHERE SCHEDULE_ID={$this->param['S_ID']}";
//echo "SQL--->{$sql}<P>";
        $row_s = $db->fetchRow($sql);

		//セッションデータにセット
		 $this->sess_set('SCHEDULE',$row_s);

		return(TRUE);

	}//end function set_ini_function

   /**
     * セッションにデータをセット
     */
	public function sess_set($ELM,$VAL,$C_NO=0){

		if( $ELM != 'COMPANION' ){
		
		foreach($VAL as $key=>$value){

			$this->sess_data[$ELM][$key] = $value;

		}//end foreach

		}else{

		foreach($VAL as $key=>$value){

			$this->sess_data[$ELM][$C_NO][$key] = $value;

		}//end foreach

		}//end if

		return(TRUE);

	}//end function sess_set

    /**
     * セッションデータをDBから取得
     */
	public function sess_db_get($SESS_ID){

        $sess = new SESSION();
        $db = $sess->getAdapter();
        $where = $db->quoteInto('SESS_ID = ?', $SESS_ID);
        $row = $sess->fetchRow($where)->toArray();

		 $result=$this->XML_to_array($row['SESS_DATA']);

		return($result);

	}//end function sess_db_get();

    /**
     * セッションデータをDBにセット
     */
	public function sess_db_set($SESS_ID=''){

			$sess = new SESSION();
      $db = $sess->getAdapter();

			//セッション情報をXMLに変換
			$SESS_DATA = $this->array_to_XML();

		if(!empty($SESS_ID)){//UPDATE

        $where = $db->quoteInto('SESS_ID = ?', $SESS_ID);

			$row = array('SESS_DATA'=>$SESS_DATA);

        	$key = $sess->update($row, $where);

			return($SESS_ID);

		}else{//INSERT

			$row = array('SESS_DATA'=>$SESS_DATA);
			$key=$sess->insert($row);
			return($key);

		}//end if

	}//end function sess_db_set();

    /**
     * SESSION 配列要素をXMLに変換する
     */
	public function array_to_XML(){

	require_once 'XML/Serializer.php';
	$options = array(
  	XML_SERIALIZER_OPTION_INDENT        => '    ',
	'defaultTagName' => 'item',
	'rootName' => 'SESSION_DATA',
	'mode' => 'simplexml',
  	XML_SERIALIZER_OPTION_RETURN_RESULT => true
 	);

	$serializer = &new XML_Serializer($options);

	$result = $serializer->serialize($this->sess_data);

/*
echo '<pre>';
echo htmlspecialchars($result);
echo '</pre>';
*/
	return($result);

	}//end function array_to_XML

    /**
     * XMLを 配列に変換する
     */
	public function XML_to_array($xml){

	require_once 'XML/Unserializer.php';

	$Unserializer =& new XML_Unserializer();
	$Unserializer->setOption('parseAttributes', TRUE);
	$status = $Unserializer->unserialize($xml);

	if (PEAR::isError($status)) {
    die($status->getMessage());
	}

	$result = $Unserializer->getUnserializedData();

	return($result);

	}//end function array_to_XML


/*************************制御系関数　ここまで*******************************/

/*************************データ処理系関数　ここから*************************/
    /**
     * デフォルトアクション
     */
    public function indexAction()
    {
	//セッションDBに情報を保存
		$this->sess_data['SESS_ID'] = $this->sess_db_set();

	//代表者修正画面を表示する
       $this->dispreserveAction();

    }//end function index

    /**
     * 代表者情報の入力・更新
     * 
     */
	public function reserveupdateAction(){

	// 入力データのチェック
	$this->table='RESERVE';
	$row = $this->ParamCheck($this->param);

	//入力データにエラーがあるときは　再表示
	if(!empty($this->ERROR)){
		$this->docomo();//DOCOMO用コード変換
$this->R_debug($this->param,'346:---param---',0,0);//1:stop 0:go 
		//代表者修正画面を表示する
		$this->sess_set('RESERVE',$this->param);
    $this->dispreserveAction();

	}else{

	//更新モード
	$this->sess_data['disp_mode'] = 'UPDATE';

	}//end if

	//同行者数の最大値をセット
 	$this->sess_data['C_MAX'] = $row['COMPANION_MAX'] - 1;

/*
$this->R_debug($this->sess_data['C_INPUT'],'---COMPANION COUNT---',0,0);//1:stop 0:go
echo "reserveupdate COMPANION_MAX {$row['COMPANION_MAX']}------<P>";
echo "reserveupdate C_MAX {$this->sess_data['C_MAX'] }------<P>";

echo "reserveupdate C_NO {$this->param['C_NO']}------<P>";
echo "reserveupdate C_INPUT {$this->sess_data['C_INPUT']}------<P>";
*/

//次の画面を判定する

		//人数が増えたか？ 
		//同行者ありでまだ誰も入力していない 
		//→同行者入力画面を表示
		if( ($this->sess_data['C_INPUT'] < $this->sess_data['C_MAX']  )
     || ( $this->sess_data['C_INPUT'] == 0  && 1 <= $this->sess_data['C_MAX']  ) ){
						// ?? && $C_MAX != 0) 

//確認画面からきて増えていたとき
//同行者入力画面から戻って増えていたとき
//同行者をまだ入力していない
//同行者が何人か入力されている

		//同行者入力画面パラメータをセット
						$this->param['C_NO'] = $this->sess_data['C_INPUT'];
						$this->companion_param_set('FORWARD');
/*
			if(empty($this->param['BACK']) && empty($this->param['UPDATE'])){
				$this->companion_param_set('FORWARD');
			}else if($this->param['C_NO'] == 0){
				$this->companion_param_set('FORWARD');
			}//end if
*/

			if($this->sess_data['C_INPUT'] < $this->sess_data['C_MAX']  ){//増えたとき

/*
					//データ有で人数増えた
					if(!empty($this->sess_data['C_MAX']) && $this->sess_data['C_MAX'] != 0 ){
						$this->param['C_NO'] = $this->sess_data['C_MAX'];
						$this->companion_param_set('FORWARD');
					}//end if
*/

//echo "DISPCOMP------データ有で増えた-C_NO SET ------{$this->param['C_NO']}";

//増えたときは表示のために初期化
					if(!empty($this->param['UPDATE'])){
						$this->param['UPDATE']=NULL;
					}else if(!empty($this->param['BACK'])){
						$this->param['BACK']=NULL;
					}//end if


			}//end if


			//セッションデータの更新
			$this->sess_set('RESERVE',$row);

			//セッションDBに情報を保存
			$this->sess_db_set($this->param['SESS_ID']);
		
			//同行者入力画面を表示する
			//更新モード
			$this->sess_data['disp_mode'] = 'INSERT';

			//

 		$this->dispcompanionAction();

		//確認画面にいく
		}else{

			//セッションデータの更新
			$this->sess_set('RESERVE',$row);

			//セッションDBに情報を保存
			$this->sess_db_set($this->param['SESS_ID']);

			//確認画面に戻る
			$this->dispconfirmAction();

		}//end if


	}//end function resrveupdate

   /**
     * 同行者情報の入力・更新
     * 
     */
	public function companionupdateAction(){

	// 入力データのチェック
	$this->table='COMPANION';
	$row = $this->ParamCheck($this->param);

$this->R_debug($this->sess_data['C_MAX'],'---COMPANION MAX---',0,0);//1:stop 0:go
$this->R_debug($this->sess_data['C_INPUT'],'---COMPANION COUNT---',0,0);//1:stop 0:go

	//入力データにエラーがあるときは　再表示
	if(!empty($this->ERROR)){
		$this->docomo();//DOCOMO用コード変換
		//同行者修正画面を表示する
		$this->sess_set('COMPANION',$this->param,$this->param['C_NO']);

		$this->dispcompanionAction();

	}else{//同行者情報の更新

			//セッションデータの更新
			$this->sess_set('COMPANION',$row, $this->param['C_NO']);
			$this->sess_set('COMPANION',$row, 0);//dummy

$this->R_debug($this->param['SESS_ID'],'---COMPANION SESS_ID---',0,0);//1:stop 0:go
$this->R_debug($this->param['C_NO'],'---COMPANION C_NO---',0,0);//1:stop 0:go
$this->R_debug($this->sess_data['COMPANION'],'---COMPANION DATA---',0,0);//1:stop 0:go

			//セッションDBに情報を保存
			$this->sess_db_set($this->param['SESS_ID']);

			//入力人数カウントアップ
			$this->sess_data['C_INPUT'] = count($this->sess_data['COMPANION'])-1;

			//更新モード
			$this->sess_data['disp_mode'] = 'UPDATE';

	}//end if

//次の画面を判定する

//入力が終わっていない
//確認画面から単独修正
		//入力完了?
		if( $this->sess_data['C_INPUT'] == $this->sess_data['C_MAX']
				|| !empty($this->param['UPDATE']) ){

			//確認画面に
			$this->dispconfirmAction();

		}else if(!empty($this->param['BACK'])){//戻ってきたとき
				//現在の番号から１を引く
				$this->param['C_NO'] = $this->param['C_NO'] - 1;

				//更新モード
				$this->sess_data['disp_mode'] = 'UPDATE';
				
				//同行者情報画面表示
					$this->dispcompanionAction();
		
		}else{// 次の同行者情報入力画面

			//同行者入力画面を表示する
			//更新モード
			$this->sess_data['disp_mode'] = 'INSERT';

			//同行者入力画面パラメータをセット
			$this->companion_param_set('FORWARD');

			$this->dispcompanionAction();

		}//end if


	}//end function companionupdate


    /**
     * 代表者情報の入力・更新
     * 
     */
	public function reservecompleteAction(){

	// 予約完了チェック（予約完了画面から戻るボタンできたとき）

	if(!empty($this->sess_data['R_ID'])){//登録済み
		$this->reserved();
	}//end if


//TRNSAction

	//代表者情報を登録
	$this->reserveinsertAction();

	//同行者がいれば同行者情報を登録
	if(1 < $this->sess_data['RESERVE']['COMPANION_MAX']
			&& !empty($this->sess_data['COMPANION'])){

		$this->companioninsertAction();

	}//end if

	// ツアー募集人数を更新
	$this->tourupdateAction();

		//セッションDBに情報を保存(予約完了を保存）
		$this->sess_db_set($this->param['SESS_ID']);

	//メール送信
		$this->Reserve_Complete_Mail();

	//予約完了画面を表示
	$this->dispreservecompleteAction();

	}//end function reservecomplete

    /**
     * ツアー募集人数を更新
     * 
     */
	public function tourupdateAction(){
	//diff >= 0 のときは募集人員をマイナス

        $row = array (
		'SCHEDULE_HEADCOUNT'	=> $this->diff
                 );

try{
      	$tour = new Tour_Schedule();
        $db = $tour->getAdapter();
//TR START
			$db->beginTransaction();

        $where = $db->quoteInto('SCHEDULE_ID = ?', $this->sess_data['S_ID']);
        $key = $tour->update($row, $where);
//コミット
			$db->commit();
//TR END
	//ツアー情報の更新　ここまで
		return(TRUE);

} catch(Zend_Db_Statement_Exception $e){
	$db->rollBack();
	print($e->getMessage());

} catch (Exception $e){
	print($e->getMessage());
}//end try

	}//end function tourupdate

    /**
     * 代表者情報のDB入力
     * 
     */
	public function reserveinsertAction(){

	// 代表者情報入力データのチェック
	$this->table='RESERVE';
	$row = $this->ParamCheck($this->sess_data['RESERVE']);

	//入力データにエラーがあるときは　再表示
	if(!empty($this->ERROR)){
		$this->docomo();//DOCOMO用コード変換
		//代表者修正画面を表示する
		$this->sess_set('RESERVE',$row);
    $this->dispreserveAction();

	}else{//代表者情報を登録

        // 代表者を取得
       $rese = new Reserve();
       $db = $rese->getAdapter();
       	 //ステータス=1
		$row['STATUS'] = 1;
		$row['TOUR_ID'] = $this->sess_data['TOUR']['TOUR_ID'];
		$row['SCHEDULE_ID'] = $this->sess_data['SCHEDULE']['SCHEDULE_ID'];
		$CREATE_TIME = date('Y/m/d H:i:s');
		$row['CREATE_TIME'] = $CREATE_TIME;
    $key=$rese->insert($row);

		//セッション情報の更新		
		//$this->sess_set('RESERVE',$row);

		//登録完了情報のセット
		$this->sess_data['R_ID']=$key;

	}//end if

		return(TRUE);

	}//end function reserveinsert

    /**
     * 同行者情報のDB入力
     * 
     */
	public function companioninsertAction(){

	//同行者情報の登録
			//まとめて全部登録

			$max = $this->sess_data['RESERVE']['COMPANION_MAX']-1;

			if( 1 <$this->sess_data['C_MAX'] ){
			foreach($this->sess_data['COMPANION'] as $key=>$value){
				//一人ずつ処理
				if($key != 0 ){
						if( $max < $key ){//人数を減らした場合は以降の情報を登録しない 
							break;
						}//end if
					$this->compinsertAction($key,$value);
				}//end if
			}//end foreach
			}else{
				//一人処理
//echo "companionINSERT------------HITORI<P>";
				$this->compinsertAction(1,$this->sess_data['COMPANION'][1]);
			}//end if

	}//end function companioninsert

    /**
     * 同行者情報のDB入力(一人ずつ）
     * 
     */
	public function compinsertAction($key,$param){

	//同行者情報の登録
	 		//CHECK & SET PARAM 
			$this->table='COMPANION';
			$row = $this->ParamCheck($param);

	//入力データにエラーがあるときは　再表示
	if(!empty($this->ERROR)){
		$this->docomo();//DOCOMO用コード変換
		//同行者修正画面を表示する
		$this->sess_set('COMPANION',$this->param,$key);
		$this->dispcompanionAction();

	}else{//同行者情報の更新

	      $comp = new Companion();
        $db = $comp->getAdapter();

				$row['COMPANION_NO'] = $key;
				$row['RESERVE_ID'] = $this->sess_data['R_ID'];
				$CREATE_TIME = date('Y/m/d H:i:s');
				$row['CREATE_TIME'] = $CREATE_TIME;

        $key=$comp->insert($row);

	}//end if

		//セッション情報の更新		
		$this->sess_set('COMPANION',$row,$key);

		return(TRUE);

	}//end function compinsert

/*************************データ処理系関数　ここまで*************************/

/*************************画面表示系関数　ここから***************************/
//VIRW CONTROLL

    /**
     * エラー画面を表示
     */
	public function  noreserveAction(){

	//エラー画面表示
       $view = new Smarty_View($this->module);

$this->R_debug($this->param,'719:---TOP_URL---',0,0);//1:stop 0:go 
$this->R_debug($this->sess_data,'720:---TOP_URL---',0,0);//1:stop 0:go 

			if(!empty($this->param['T_ID'])){
	 			$view->assign("T_ID", $this->param['T_ID']);
			}else{
	 			$view->assign("T_ID", $this->sess_data['TOUR']['TOUR_ID']);
			}//end if
      
			if(!empty($this->param['SESS_ID'])){
	 			$view->assign("SESS_ID", $this->param['SESS_ID']);
			}//end if

		  $view->assign("title", "予約入力");
	 		$view->assign("CARRIER", $this->CARRIER[0]);
      $view->assign('SCHEDULE_DATE', $this->sess_data['SCHEDULE']['SCHEDULE_DATE']);
	 		$view->assign("TOUR_URL", $this->sess_data['TOUR']['TOUR_URL']);
	 		$view->assign("BASE_URL", $this->base_url);
	 		$view->assign("TOP_URL", $this->top_url);

			if(!empty($this->param['SESS_ID']) && empty($this->param['S_CHANGE'])){
			//はじめてではない && 日付変更でない（予約入力時）
       			$view->showPage('template.tpl','ReserveError',$this->CARRIER[0]);
			}else{
       			$view->showPage('template.tpl','ReserveErrorTop',$this->CARRIER[0]);
			}//end if

	//表示して終了
		exit();
	}//end function disperror

    /**
     * 代表者入力（更新）画面を表示
     */
	public function dispreserveAction(){

	//代表者入力画面表示
	//初めて表示する場合
	$view = new Smarty_View($this->module);

	if($this->sess_data['disp_mode'] != 'UPDATE'){

		$view->assign("title", "予約入力(代表者情報入力)");

	}else{

		$view->assign("title", "予約入力(代表者情報更新)");

	}//end if

	//日程情報から人数のプルダウンを作成する
	 $hc=$this->head_count($this->sess_data['S_ID']);
	 $view->assign("hc", $hc);

		$view->assign("sess_data", $this->sess_data);
		$view->assign("error", $this->ERROR);

		//確認画面から来たとき
		if(!empty($this->param['UPDATE'])){
			$view->assign("UPDATE", $this->param['UPDATE']);
		}else if(!empty($this->param['BACK'])){
			$view->assign("BACK", $this->param['BACK']);
		}//end if

	// 画面表示
	 		$view->assign("CARRIER", $this->CARRIER[0]);
	 		$view->assign("DATA_TYPE", $this->DATA_TYPE);
	 		$view->assign("TOUR_URL", $this->sess_data['TOUR']['TOUR_URL']);
	 		$view->assign("BASE_URL", $this->base_url);
	 		$view->assign("TOP_URL", $this->top_url);

	$view->showPage('template.tpl','ReserveInput',$this->CARRIER[0]);

	//表示して終了
		exit();

	}//end function dispreserve

    /**
     * 同行者入力（更新）画面を表示
     */
	public function dispcompanionAction(){

/*
echo "-DISP COMPANION ------<PRE>";
var_dump($this->param);
echo "</PRE>";

echo "-DISP COMPANION C_NO-----{$this->param['C_NO']}";

echo "-DISP COMPANION -222-----<PRE>";
var_dump($this->sess_data['COMPANION'][$this->param['C_NO']]);
echo "</PRE>";
*/

	//同行者入力画面表示
	//初めて表示する場合
	$view = new Smarty_View($this->module);

	if(!empty($this->param['UPDATE'])){//確認画面から単独指定
			$this->param['C_BEFORE'] = $this->param['C_NO']-1;
			$this->param['C_NEXT']   = $this->param['C_NO']+1;
			$view->assign("UPDATE", $this->param['UPDATE']);
	}//end if

	if(!empty($this->param['BACK'])){//同行者情報入力画面からBACK
			$this->param['C_BEFORE'] = $this->param['C_NO']-1;
			$this->param['C_NEXT']   = $this->param['C_NO']+1;
			$view->assign("BACK", $this->param['BACK']);
	}//end if

	if($this->sess_data['disp_mode'] != 'UPDATE'){

		$view->assign("title", "予約入力(同行者情報入力)");

	}else{

		$view->assign("title", "予約入力(同行者情報更新)");

	}//end if

	//更新モード

	if(!empty($this->sess_data['COMPANION'][$this->param['C_NO']])){
		$view->assign("companion", $this->sess_data['COMPANION'][$this->param['C_NO']]);
	}//end if

	 $view->assign("C_NO", $this->param['C_NO']);

	if(!empty($this->param['C_BEFORE'])){
	 	$view->assign("C_BEFORE", $this->param['C_BEFORE']);
	}//end if

	 //$view->assign("C_NEXT", $this->param['C_NEXT']);
	 $view->assign("sess_data", $this->sess_data);
	 $view->assign("error", $this->ERROR);

	// 画面表示
	 		$view->assign("CARRIER", $this->CARRIER[0]);
	 		$view->assign("DATA_TYPE", $this->DATA_TYPE);
	 		$view->assign("TOUR_URL", $this->sess_data['TOUR']['TOUR_URL']);
	 		$view->assign("BASE_URL", $this->base_url);
	 		$view->assign("TOP_URL", $this->top_url);

	$view->showPage('template.tpl','CompanionInput', $this->CARRIER[0]);

	//表示して終了
		exit();

	}//end function dispcompanion


   /**
     * データ確認画面表示
     */
    public function dispconfirmAction()
    {
 
//View 
     $view = new Smarty_View($this->module);

		 $view->assign("title", "予約内容確認画面");

		 $yyyy = substr($this->sess_data['RESERVE']['BIRTHDAY'],0,4);
		 $mm   = substr($this->sess_data['RESERVE']['BIRTHDAY'],4,2);
		 $dd   = substr($this->sess_data['RESERVE']['BIRTHDAY'],6,2);

		 $view->assign("yyyy", $yyyy);
		 $view->assign("mm", $mm);
		 $view->assign("dd", $dd);

		 $view->assign("sess_data", $this->sess_data);

	if(!empty($this->sess_data['COMPANION'])){
		
				foreach($this->sess_data['COMPANION'] as $key=>$comp ){
					if( $key != 0 ){

		 				$yyyy = substr($comp['BIRTHDAY'],0,4);
		 				$mm   = substr($comp['BIRTHDAY'],4,2);
		 				$dd   = substr($comp['BIRTHDAY'],6,2);
						$comp['yyyy'] = $yyyy;
						$comp['mm']   = $mm;
						$comp['dd']   = $dd;
						$arr[] = $comp;
					}//end if
				}//end foreach 

	$view->assign("companion", $arr);

	}//end if

 			$view->assign("CARRIER", $this->CARRIER[0]);
	 		$view->assign("TOUR_URL", $this->sess_data['TOUR']['TOUR_URL']);
	 		$view->assign("BASE_URL", $this->base_url);
	 		$view->assign("TOP_URL", $this->top_url);

       $view->showPage('template.tpl','ReserveConfirm',$this->CARRIER[0]);


    }

    /**
     * 予約完了画面表示
     */
		public function dispreservecompleteAction(){

    $view = new Smarty_View($this->module);
  	$view->assign("param", $this->sess_data);

	 	$view->assign("title", "予約完了");
	 	$view->assign("CARRIER", $this->CARRIER[0]);
	 		$view->assign("TOUR_URL", $this->sess_data['TOUR']['TOUR_URL']);
	 		$view->assign("BASE_URL", $this->base_url);
	 		$view->assign("TOP_URL", $this->top_url);

    $view->showPage('template.tpl','ReserveComplete',$this->CARRIER[0]);

	}//end function dispreservecomplete




    /**
     * 同行者情報表示パラメタのセット
     */
    public function companion_param_set($KEYWORD)
    {
		switch($KEYWORD){
	//FORWARD
			case 'FORWARD':
					$this->param['C_NO'] += 1;
//echo "param set C_NO--------{$this->param['C_NO']}<P>";
					break;
	//BACK
			case 'BACK':
					$this->param['C_NO'] -= 1;
					break;
	//UPDATE
			default:
					break;
		}//end switch

		$this->param['C_BEFORE'] = $this->param['C_NO']-1;
		$this->param['C_NEXT'] = $this->param['C_NO']+1;
//echo "param set C_BEFORE--------{$this->param['C_BEFORE']}<P>";
//echo "param set C_NEXT--------{$this->param['C_NEXT']}<P>";

    }//end function

/*************************画面表示系関数　ここまで***************************/

/*************************データ処理補助系関数　ここから*********************/

    /**
     *   入力チェック insertのときはパラメータなし
     * 			　updateのときは$act='UPDATE'
     */
    public function ParamCheck($param,$act="")
    {
require_once HIS_APP.'lib/ErrorMessages.php';

	if(!empty($param['NAME_SEI'])){
		$row['NAME_SEI'] 	= htmlspecialchars($param['NAME_SEI']);
//DOCOMO 
		if($this->CARRIER[0] == 'DOCOMO' || $this->CARRIER[0] == 'KDDI' ){
			$row['NAME_SEI'] = mb_convert_encoding($row['NAME_SEI'], "UTF-8", "auto");
		}//end if

	}else{
		$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_SEI];
	}//end if

	if(!empty($param['NAME_MEI'])){
		$row['NAME_MEI']	= htmlspecialchars($param['NAME_MEI']);
//DOCOMO 
		if($this->CARRIER[0] == 'DOCOMO' || $this->CARRIER[0] == 'KDDI' ){
			$row['NAME_MEI'] = mb_convert_encoding($row['NAME_MEI'], "UTF-8", "auto");
		}//end if
	}else{
		$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_MEI];
	}//end if


	if(!empty($param['NAME_SEI_ALP'])){
		if(!$this->eisuzi(trim($param['NAME_SEI_ALP']))){
			$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_SEI_ALP];
		}else{
			$row['NAME_SEI_ALP']	= htmlspecialchars(trim($param['NAME_SEI_ALP']));
		}//end if
	}else{
		$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_SEI_ALP];
	}//end if

	if(!empty($param['NAME_MEI_ALP'])){
		if(!$this->eisuzi(trim($param['NAME_MEI_ALP']))){
			$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_MEI_ALP];
		}else{
			$row['NAME_MEI_ALP']	= htmlspecialchars(trim($param['NAME_MEI_ALP']));
		}//end if
	}else{
		$this->ERROR[]=$ERROR_MESSAGE[ER_NAME_MEI_ALP];
	}//end if

	if(!empty($param['BIRTHDAY'])){

		$hizuke=trim($param['BIRTHDAY']);

		$yy=intval(substr(trim($hizuke),0,4));

		//+1 年より先の年はすべてエラー
		$Y=date('Y',strtotime('1 year'));

		if( $Y <= $yy ){
					$this->ERROR[]=$ERROR_MESSAGE[ER_BIRTHDAY_2];
		}else{//今年より先を指定したらエラー

		$mm=intval(substr($hizuke,4,2));
		$dd=intval(substr($hizuke,6,2));

		if(!$this->suzi($hizuke)){
			$this->ERROR[]=$ERROR_MESSAGE[ER_BIRTHDAY_1];
		}elseif(checkdate($mm,$dd,$yy) != TRUE || (time() < strtotime($hizuke))){
			$this->ERROR[]=$ERROR_MESSAGE[ER_BIRTHDAY_2];
		}else{
			$row['BIRTHDAY'] = htmlspecialchars($hizuke);
		}//end if

		}//end if

	}else{//誕生日を入力してください
		$this->ERROR[]=$ERROR_MESSAGE[ER_BIRTHDAY];
	}//end if


	if(!empty($param['SEX'])){
		$row['SEX']	= htmlspecialchars($param['SEX']);
	}else{
		$this->ERROR[]=$ERROR_MESSAGE[ER_SEX];
	}//end if

if( $this->table == 'RESERVE'){
//echo "-----------{$this->table}<P>";

	if(!empty($param['T_ID'])){
		$row['TOUR_ID']	= htmlspecialchars($param['T_ID']);
	}else if(!empty($param['TOUR_ID'])){
		$row['TOUR_ID']	= htmlspecialchars($param['TOUR_ID']);
	}//end if

	if(!empty($param['EMAIL_ADDRESS'])){
		if(!$this->email_check(trim($param['EMAIL_ADDRESS']))){
			$this->ERROR[]=$ERROR_MESSAGE[ER_MAIL];
		}else{
			$row['EMAIL_ADDRESS']	= htmlspecialchars(trim($param['EMAIL_ADDRESS']));
		}//end if
	}else{
		$this->ERROR[]=$ERROR_MESSAGE[ER_MAIL];
	}//end if

	if(!empty($param['TEL_NO'])){
		if(!$this->suzi(trim($param['TEL_NO']))){
			$this->ERROR[]=$ERROR_MESSAGE[ER_TEL_NO];
		}else{
			$row['TEL_NO']		= htmlspecialchars(trim($param['TEL_NO']));
		}//end if
	}else{
		$this->ERROR[]=$ERROR_MESSAGE[ER_TEL_NO];
	}//end if


		$row['ADDRESS1']		= htmlspecialchars(trim($param['ADDRESS1']));

		$row['ADDRESS2']		= htmlspecialchars(trim($param['ADDRESS2']));

  	$row['ADDRESS3']		= htmlspecialchars(trim($param['ADDRESS3']));

//DOCOMO 
		if($this->CARRIER[0] == 'DOCOMO' || $this->CARRIER[0] == 'KDDI' ){
			if(!empty($row['ADDRESS1'])){
				$row['ADDRESS1'] = mb_convert_encoding($row['ADDRESS1'], "UTF-8", "auto");
			}//end if
			if(!empty($row['ADDRESS2'])){
				$row['ADDRESS2'] = mb_convert_encoding($row['ADDRESS2'], "UTF-8", "auto");
			}//end if
			if(!empty($row['ADDRESS3'])){
				$row['ADDRESS3'] = mb_convert_encoding($row['ADDRESS3'], "UTF-8", "auto");
			}//end if
		}//end if


	if(!empty($param['COMPANION_MAX']) OR $param['COMPANION_MAX'] == 0){
		$row['COMPANION_MAX']	= htmlspecialchars($param['COMPANION_MAX']);
	}//end if

}else{//$table=COMPANION

	if(!empty($param['COMPANION_NO'])){
		$row['COMPANION_NO']		= htmlspecialchars($param['COMPANION_NO']);
	}//end if

}//end if 

	if(!empty($act)){
		$row['UPDATE_TIME']= date('Y/m/d H:i:s');
	}else{
		$row['CREATE_TIME']= date('Y/m/d H:i:s');
	}//end if

	return $row;

     }//end function


    /**
     * 予約完了メール送信
     * 			
     */
		public function Reserve_Complete_Mail(){

//予約完了　メール送信
	$config = new Zend_Config_Ini(HIS_APP .'config/config.ini', 'production');
	$From =	$config->MailFrom;;//configに定義
	$To = $this->sess_data['RESERVE']['EMAIL_ADDRESS'];
	$Subject ="HIS 予約受付";

	$data=array();
        $data = $this->sess_data['RESERVE'];


	//require_once 'ReserveConfMail.tpl';
//出発日
list($Dep_yy,$Dep_mm,$Dep_dd)=explode('-',$this->sess_data['SCHEDULE']['SCHEDULE_DATE']);
//BIRTHDAY
	  $hizuke=trim($data['BIRTHDAY']);
		$yy=intval(substr(trim($hizuke),0,4));
		$mm=intval(substr($hizuke,4,2));
		$dd=intval(substr($hizuke,6,2));


	if($data['SEX'] != 2)
	{
		$SEX='男性';
	}else{
		$SEX='女性';
	}//end if


$Body="
{$data['NAME_SEI']} {$data['NAME_MEI']}様\n
\n
このたびは「{$this->sess_data['TOUR']['TOUR_NAME']}」をご予約いただき誠にありがとうございます。\n

ご予約いただいた内容をお知らせいたします。\n
\n
ﾂｱｰｺｰﾄﾞ：{$this->sess_data['TOUR']['TOUR_CODE']}\n
ﾂｱｰ名：{$this->sess_data['TOUR']['TOUR_NAME']}\n

出発日：{$Dep_yy}年{$Dep_mm}月{$Dep_dd}日\n
お名前：{$data['NAME_SEI']} {$data['NAME_MEI']}\n
お名前（ｱﾙﾌｧﾍﾞｯﾄ）：  {$data['NAME_MEI_ALP']} {$data['NAME_SEI_ALP']}\n
ﾒｰﾙｱﾄﾞﾚｽ:{$data['EMAIL_ADDRESS']}\n
生年月日：{$yy}年{$mm}月{$dd}日\n
性別：{$SEX}\n
電話番号：{$data['TEL_NO']}\n
住所：{$data['ADDRESS1']}{$data['ADDRESS2']}{$data['ADDRESS3']}\n
\n
人数：{$data['COMPANION_MAX']}人\n

ご予約いただきました内容につきましては、後ほどｺｰﾙｾﾝﾀｰより
確認のご連絡をさせていただきます。\n

";

//echo "メール本文　返還前----><P>{$Body}<P>";

	//文字コード設定
	
	if($this->CARRIER[0] != 'SB'){
		$mailCharset='shift-jis';	
	  $crrCharset='utf-8';
		$Subject  = mb_convert_encoding($Subject, $mailCharset ,$crrCharset);
		$Body     = mb_convert_encoding($Body, $mailCharset ,$crrCharset);

	}else{//SOFTBANK

		$mailCharset='ISO-2022-JP';
	    $crrCharset='utf-8';
		$Subject  = mb_encode_mimeheader($Subject, $mailCharset );

		//$Body=base64_encode($Body);

		//$Body= mb_convert_encoding($Body, $mailCharset ,$crrCharset);

		//$Body=base64_decode($Body);



	}//end if


//echo "メール本文　AFTER----><P>{$Body}<P>";

	$this->mail_send($From,$To,$Subject,$Body);

		return(TRUE);

		}//end function  Reserve_Complete_Mail  



    /**
     * メール送信　ざっくり！
     * 			
     */

	public function mail_send($From,$To,$Subject,$Body){

	require_once "Mail.php";

	$config = new Zend_Config_Ini(HIS_APP .'config/config.ini', 'production');
	$host =	$config->host;//configに定義
	$port =	$config->port;//configに定義
	$auth =	$config->auth;//configに定義
	$username =	$config->username;//configに定義
	$password =	$config->password;//configに定義

	$params = array(
  	'host' =>$host,
  	'port' =>$port,
  	'auth' =>$auth,
  	'username' =>$username,
  	'password' =>$password
	);

	$recipients = $To;

	$headers['From']    = $From;
	$headers['To']      = $To;
	$headers['Subject'] = $Subject;

	/***/
	if($this->CARRIER[0] != 'SB'){
	}else{
		$headers['Content-Type'] = 'text/plain; charset=UTF-8';
		$headers['MIME-Version'] = '1.0';
		$headers['Content-Transfer-Encoding'] = 'base64';
	}//end if
	/***/


	$body = $Body;

/*
	$objMail =& Mail::factory('smtp', $params);
	$result = $objMail->send($recipients, $headers, $body);
	if (PEAR::isError($result)) {
	//echo "メール送信NG!!";
  		return -1;
	}else{
	//echo "メール送信OK!!";
		return 1;
	}
*/

$mail = & new Qdmail( 'UTF-8' , 'base64' );
$mail -> charsetHeader( 'iso-2022-jp' , '7bit' ) ;
$mail -> charsetBody( 'utf-8' , 'base64' ) ;
$mail -> to($To);
$mail -> subject($Subject);
$mail -> text( $Body );
$mail -> from( $From );

$mail ->send();


	}//end function


    /**
     * 予約可能か否かのチェック
     * ツアー募集人数と同行者の人数の差を返す
     */
       /**
     * 予約可能か否かのチェック
     * ツアー募集人数と同行者（＋１）の人数の差を返す
     */
    public function bookable($s_id,$comp_max){

        $sche = new Tour_Schedule();
        $db = $sche->getAdapter();

	$sql="SELECT SCHEDULE_HEADCOUNT FROM M_TOURPACKAGE_SCHEDULE WHERE SCHEDULE_ID={$s_id}";
//echo "SQL--->{$sql}<P>";
        $h_cnt = $db->fetchRow($sql);

//echo "<P>-->>>>>>>>>{$h_cnt['SCHEDULE_HEADCOUNT']}-<P>";
	
	//募集人数から人数を差し引く
	$diff= $h_cnt['SCHEDULE_HEADCOUNT']-$comp_max;

	return($diff);

    }//end function bookable


   /**
     * 人数プルダウンの作成
     * プルダウンに表示する人数を返す
     */
    public function head_count($s_id){

        $sche = new Tour_Schedule();
        $db = $sche->getAdapter();

	$sql="SELECT * FROM M_TOURPACKAGE_SCHEDULE WHERE SCHEDULE_ID={$s_id}";
//echo "SQL====>{$sql}<P>";
        $row = $db->fetchRow($sql);

//echo "{$row['SCHEDULE_HEADCOUNT']}<P>";

	if(empty($row['SCHEDULE_MINI'])){
		$row['SCHEDULE_MINI'] = 1;
	}//end if

	if(empty($row['SCHEDULE_MAX'])){
		$row['SCHEDULE_MAX'] = 1;
	}//end if
		

	//最小人数から最大人数まで
 	if( $row['SCHEDULE_ODD'] ){
		for($i=$row['SCHEDULE_MINI'];$i<=$row['SCHEDULE_MAX'];$i++){
	    		if( $i%2 == 0 ){//奇数不可のときは偶数のみ
				$hc[] = $i;
//echo "奇数不可=======================>{$i}<P>";	
				if( $row['SCHEDULE_HEADCOUNT'] <= $i )
					break;
			}//end if
		}//end for

	}else{
		for($i=$row['SCHEDULE_MINI'];$i<=$row['SCHEDULE_MAX'];$i++){
            		      if( $row['SCHEDULE_THREE'] && $i == 3 ){
	    		}else if( $row['SCHEDULE_FIVE'] && $i == 5 ){
  	    		}else if( $row['SCHEDULE_HEADCOUNT'] <= $i ){
				$hc[] = $i;
				break;
	    		}else{
//echo "=======================>{$i}<P>";	
				$hc[] = $i;
	   		 }//end if

		}//end for

	}//end if


	if(empty($hc)){
		$hc[0]=1;
	}//end if

	return($hc);

    }//end function head_count

    /**
     * 英数字チェック
     */
	public function eisuzi($string){

	if (preg_match("/^[a-zA-Z0-9]+$/", $string)) {
		return 1;
	}
	else{
		return 0;
	}//end if

	}

    /**
     * 数字チェック
     */
	public function suzi($string){

	if (preg_match("/^[0-9]+$/", $string)) {
		return 1;
	}else{
		return 0;
	}//end if
	}

    /**
     * メールアドレスチェック
     */
	public function email_check($mailaddress){

	if (preg_match('/^[a-zA-Z0-9_\.\-]+@[A-Za-z0-9]+(\.[A-Za-z0-9_\.\-]+)+$/',$mailaddress))
	{
		return 1;
	}
	else{
		return 0;
	}//end if

	}


    /**
     * 予約済みチェック 
     * 予約済みの場合は予約完了画面を表示する
     */
	public function reserved(){

	//View 
    $view = new Smarty_View($this->module);

	 		$view->assign("title", "予約完了済み");
	 		$view->assign("Message", "RESERVED");
	 		$view->assign("CARRIER", $this->CARRIER[0]);
	 		$view->assign("TOUR_URL", $this->sess_data['TOUR']['TOUR_URL']);
	 		$view->assign("BASE_URL", $this->base_url);
	 		$view->assign("TOP_URL", $this->top_url);

         $view->showPage('template.tpl','Message',$this->CARRIER[0]);


	die('');
	}//end function

  /**
     * DOCOMO
     */
    public function docomo()
    {
$this->R_debug($this->CARRIER[0],'1447:---CARRIER---',0,0);//1:stop 0:go ::1:do 0:pass
			if( $this->CARRIER[0] != 'DOCOMO' || $this->CARRIER[0] != 'KDDI' ){
			}else{

				if(!empty($this->param['NAME_SEI'])){
					$this->param['NAME_SEI'] = mb_convert_encoding($this->param['NAME_SEI'], "UTF-8", "auto");
				}//end if
				if(!empty($this->param['NAME_MEI'])){
					$this->param['NAME_MEI'] = mb_convert_encoding($this->param['NAME_MEI'], "UTF-8", "auto");
				}//end if
				if(!empty($this->param['ADDRESS1'])){
					$this->param['ADDRESS1'] = mb_convert_encoding($this->param['ADDRESS1'], "UTF-8", "auto");
				}//end if
				if(!empty($this->param['ADDRESS2'])){
					$this->param['ADDRESS2'] = mb_convert_encoding($this->param['ADDRESS2'], "UTF-8", "auto");
				}//end if
				if(!empty($this->param['ADDRESS3'])){
					$this->param['ADDRESS3'] = mb_convert_encoding($this->param['ADDRESS3'], "UTF-8", "auto");
				}//end if
$this->R_debug($this->param,'1466:--param---',1,0);//1:stop 0:go 
		}//end if

		}//end function
/*************************データ処理補助系関数　ここまで*********************/

/*************************例外・エラー系関数　ここから***********************/

    /**
     * アクション名が見つからない
     */
    public function __call($methodName, $args)
    {
        header('HTTP/1.1 404 Not found');
	throw new Exception('例外です');
        $view = new My_View();
        $view->pageTitle = '404 Not found';
        $view->content = '指定ページが見つかりません';
        $view->showPage();
    }

	public function R_debug($value,$Mess,$s_or_g=0,$n=1){

			if($n == 0){
				return(TRUE);
			}//end if

			if(is_array($value)){
				echo "{$Mess}--START--<PRE>";
				var_dump($value);
				echo "{$Mess}--END--</PRE>";
			}else{
				echo "{$Mess}--START--<P>";
				echo  $value;
				echo "<br>{$Mess}--END--<P>";
			}//end if
	
		if($s_or_g == 1){
			die("STOP!!------{$Mess}-----");
		}//end if


		return(1);

	}//end function


/*************************例外・エラー系関数　ここまで***********************/

}//end class

