<?php
require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Table.php';

require_once CRAFT_APP . 'models/DataBase.php';
require_once CRAFT_APP.'lib/Smarty/View.php';

class PageeditController extends Zend_Controller_Action 
{

    /**
     * initANV
     */
    public function init()
    {
		$req = $this->getRequest();

		$this->module     = $req->getModuleName();
		$this->controller = $req->getControllerName();
    }

    /**
     * \ʂҏW
     */
    public function indexAction()
    {

        $param = Zend_Controller_Action::_getAllParams();

	/* Action */
	$t = new Layout_Parts;
        $db = $t->getAdapter();

	if(!empty($param['A_ID'])){
		$A_ID = $param['A_ID'];
	}else{
		$A_ID = 1;
	}//end if

        	$sql="
			SELECT * 
			FROM `layout_parts` 
			WHERE action_id={$A_ID} AND 0 < parts_order
			ORDER BY `div_name` , `parts_order` 
              	";



//echo "SQL--->{$sql}<P>";

        $Layout_Parts = $db->fetchAll($sql);

	foreach($Layout_Parts as $i =>$l_parts){//foreach1
		switch( $l_parts['div_name'] ){
			case 'header':
				$Header[]= $l_parts['template_name'];
				break;
			case 'left':
				$Left[]= $l_parts['template_name'];
				break;
			case 'center':
				$Center[]= $l_parts['template_name'];
				break;
			case 'right':
				$Right[]= $l_parts['template_name'];
				break;
			case 'footer':
				$Footer[]= $l_parts['template_name'];
				break;
		}//end switch

		/* ҏWs */

		if(!empty($l_parts['action_name'])){
			$display["{$l_parts['parts_name']}"] = $this->$l_parts['action_name']($param);
		}//end if

	}//foreach1 end

	/* Null Check */

	if( empty($Header) ){
		$Header = null;
	}//end if
	if( empty($Left) ){
		$Left = null;
	}//end if
	if( empty($Center) ){
		$Center = null;
	}//end if
	if( empty($Right) ){
		$Right = null;
	}//end if
	if( empty($Footer) ){
		$Footer = null;
	}//end if


		$view = new Smarty_View();

			$layout=array(
            		'header'=>$Header,
			'left'=>$Left,
			'center'=>$Center,
			'right'=>$Right,
			'footer'=>$Footer
			);	

	 			$view->assign("display", $display);
	 			$view->assign("layout", $layout);
    				$view->showPage('template.tpl');


    }//end IndexAction 

    /**
     * ListʂҏW
     */
    public function listAction($param)
    {

	$p_basic = new P_Basic;
        $db = $p_basic->getAdapter();

	if(!empty($param['ch'])){
		$channel = $param['ch'];
	}else{
		$channel = 1;
	}//end if

        	$sql="
			SELECT * 
			FROM p_basic 
			WHERE CHANNEL={$channel} AND DEL_FLG != 1 ORDER BY REC_ID DESC
              	";

	$db->query("SET CHARSET 'sjis';");

        $List= $db->fetchAll($sql);

	foreach($List as $i =>$list){//foreach1

		$display[] =array('date'=>$list['REG_DATE'],'title'=>$list['TITLE'],'id'=>$list['REC_ID']);

	}//end foreach1

	return($display);

    }//end listAction


    /**
     * ڍ׉ʂҏWiLPj
     */
    public function detailAction($param)
    {

/* L{̒o@*/

	$p_basic = new P_Basic;
        $db = $p_basic->getAdapter();

	if(!empty($param['id'])){
		$id = $param['id'];
	}else{
		$id = 0;
	}//end if

        	$sql="
			SELECT * 
			FROM p_basic 
			WHERE  REC_ID='{$id}' AND DEL_FLG != 1
              	";

	$db->query("SET CHARSET 'sjis';");


        $basic = $db->fetchRow($sql);

/* ʐ^̒o@*/

	$p_data = new P_Data;
        $db = $p_data->getAdapter();

        	$sql="
			SELECT * 
			FROM p_data 
			WHERE  Za_REC='{$id}' 
			ORDER BY Za_PRIO
              	";

	$db->query("SET CHARSET 'sjis';");

        $data = $db->fetchAll($sql);

	$display=array('date'=>$basic['REG_DATE'],'title'=>$basic['TITLE'],'memo'=>$basic['MEMO']
			,'img'=>$data);


	return($display);

    }//end detailAction
    
    

    /**
     * ANVȂ
     */
    public function __call($methodName, $args)
    {
        $param = Zend_Controller_Action::_getAllParams();
	$req = $this->getRequest();
echo "module------------>{$req->getModuleName()}<P>";
echo "ctrl------------>{$req->getControllerName()}<P>";
echo "action------------>{$req->getActionName()}<P>";
        $this->_redirect("/{$param['controller']}/");
    }

}
