<?php
require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Table.php';


require_once HIS_APP . 'models/Tour.php';
require_once HIS_APP.'lib/Smarty/View.php';

class Backyard_TourController extends Zend_Controller_Action 
{
public $module;
public $controller;

    /**
     * initアクション
     */
    public function init()
    {
		$req = $this->getRequest();

		$this->module     = $req->getModuleName();
		$this->controller = $req->getControllerName();

echo "module------------>{$req->getModuleName()}<P>";
echo "ctrl------------>{$req->getControllerName()}<P>";
echo "action------------>{$req->getActionName()}<P>";
    }

    /**
     * デフォルトアクション
     */
    public function indexAction()
    {
        // 全ての行を取得
       $param = Zend_Controller_Action::_getAllParams();

	$view = new Smarty_View($this->module);

	//$view->assign("Rows", $rows);
        $view->showPage('template.tpl','top_menu');


    }
   /**
     * edit Dispアクション
     */
    public function editdispAction()
    {
        // 全ての行を取得
       $param = Zend_Controller_Action::_getAllParams();

echo "key------------>{$param['key']}<P>";

	$view = new Smarty_View($this->module);
/*
	$view->assign("module", $req->getModuleName());
	$view->assign("ctrl", $req->getControllerName());
	$view->assign("action", $req->getActionName());
        $view->showPage('template.tpl','user');
*/
        $mssg = new Messages();
        $rows = $mssg->fetchAll()->toArray();
//Smartyに連想配列を渡す（assignする）
	$view->assign("Rows", $rows);
        $view->showPage('template.tpl','DbList');


    }

    /**
     * editアクション
     */
    public function editAction()
    {
        $param = Zend_Controller_Action::_getAllParams();

        $view = new Smarty_View($this->module);

        $view->pageTitle = "{$param['controller']} Sample";

        // 指定したidの行を取得
        $mssg = new Messages();
        $db = $mssg->getAdapter();
        $where = $db->quoteInto('id = ?', $param['id']);
        $row = $mssg->fetchRow($where)->toArray();
	 $view->assign("messages", $row);
        $view->showPage('template.tpl','DbEdit');
    }

    /**
     * データ入力画面表示
     */
    public function inputAction()
    {
 
//View 
        $view = new Smarty_View($this->module);
 //Smartyに連想配列を渡す（assignする）
        $param = Zend_Controller_Action::_getAllParams();
        $view->assign('param', $param);
        $view->assign('title', 'ツアー登録');
        $view->showPage('template.tpl','TourInput');

    }

  /**
     * データ確認画面表示
     */
    public function confirmAction()
    {
 

 //Smartyに連想配列を渡す（assignする）
        $param = Zend_Controller_Action::_getAllParams();
/*
	 $sess = new Zend_Session_Namespace('TOUR');
	 $sess->__set('para',$param['T_CODE']);
*/
//View 
        $view = new Smarty_View($this->module);
        $view->assign('title', 'ツアー登録確認');
        $view->assign('param', $param);
        $view->showPage('template.tpl','TourConf');

    }



    /**
     * insertアクション
     */
    public function insertAction()
    {
         $param = Zend_Controller_Action::_getAllParams();
/*
	  $sess = new Zend_Session_Namespace('TOUR');
	  $p= $sess->__get('para');
	 
echo "<PRE>";
var_dump($p);
echo "</PRE>";
*/

	
	 //CHECK & SET PARAM CLASS 
	//TEMP EASY CHECK 2008/12/22

	//SET PARAM
	
        $row = array (
		'TOUR_CODE' 	=> $param['T_CODE'],
		'TOUR_NAME' 	=> $param['T_NAME'],
		'TOUR_COMMENT'=> $param['T_COMMENT'],
		'CREATE_TIME'	=> date('Y/m/d H:i:s')
                 );

	if(!empty($param['T_URL'])){
		$row['TOUR_URL'] 	= $param['T_URL'];
	}//end if

	if(!empty($param['T_IMG'])){
		$row['TOUR_IMG']	= $param['T_IMG'];
	}//end if

	if(!empty($param['T_DEFAULT_PRICE'])){
		$row['TOUR_DEFAULT_PRICE']	= $param['T_DEFAULT_PRICE'];
	}//end if

	if(!empty($param['T_DEFAULT_HEADCOUNT'])){
		$row['TOUR_DEFAULT_HEADCOUNT'] = $param['T_DEFAULT_HEADCOUNT'];
	}//end if

	if(!empty($param['T_DEFAULT_MAX'])){
		$row['TOUR_DEFAULT_MAX']	= $param['T_DEFAULT_MAX'];
	}//end if

	if(!empty($param['T_DEFAULT_MINI'])){
		$row['TOUR_DEFAULT_MINI']	= $param['T_DEFAULT_MINI'];
	}//end if

	if(!empty($param['T_DEFAULT_THREE'])){
		$row['TOUR_DEFAULT_THREE'] 	= $param['T_DEFAULT_THREE'];
	}//end if

	if(!empty($param['T_DEFAULT_FIVE'])){
		$row['TOUR_DEFAULT_FIVE']		= $param['T_DEFAULT_FIVE'];
	}//end if

	if(!empty($param['T_DEFAULT_ODD'])){
		$row['TOUR_DEFAULT_ODD']		= $param['T_DEFAULT_ODD'];
	}//end if



echo "<PRE>";
var_dump($row);
echo "</PRE>";

        // 行の挿入

        $tour = new Tour();
        $key=$tour->insert($row);


echo "{$key}  が登録されました<P>";
echo "{$param['controller']}<P>";
//View 
        $view = new Smarty_View($this->module);
        $view->assign('title', 'ツアー登録完了');
        $view->assign('T_ID', $key);
        $view->assign('param', $param);
        $view->showPage('template.tpl','TourComplete');

        //$this->_redirect("/{$this->module}/{$this->controller}");
    }

   /**
     * 日程データ入力画面表示
     */
    public function scheduleinputAction()
    {
 
//View 
        $view = new Smarty_View($this->module);
 //Smartyに連想配列を渡す（assignする）
        $param = Zend_Controller_Action::_getAllParams();
        $view->assign('param', $param);
        $view->assign('title', 'ツアー登録');
        $view->showPage('template.tpl','ScheduleInput');

    }

 /**
     * 日程データ確認画面表示
     */
    public function scheduleconfirmAction()
    {
 

 //Smartyに連想配列を渡す（assignする）
        $param = Zend_Controller_Action::_getAllParams();
echo "------><PRE>";
var_dump($param);
echo "</PRE>------";
//View 
        $view = new Smarty_View($this->module);
        $view->assign('title', 'ツアー登録確認');
        $view->assign('param', $param);
        $view->showPage('template.tpl','ScheduleConfirm');

    }

    /**
     * 日程insertアクション
     */
    public function scheduleinsertAction()
    {
         $param = Zend_Controller_Action::_getAllParams();
	
	 //CHECK & SET PARAM CLASS 
	//TEMP EASY CHECK 2008/12/22

	//SET PARAM
	
        $row = array (
		'TOUR_ID' 	=> $param['T_ID'],
		'CREATE_TIME'	=> date('Y/m/d H:i:s')
                 );

	if(!empty($param['S_DATE'])){
		$row['SCHEDULE_DATE'] 	= $param['S_DATE'];
	}//end if

	if(!empty($param['S_PRICE'])){
		$row['SCHEDULE_PRICE']	= $param['S_PRICE'];
	}//end if

	if(!empty($param['S_HEADCOUNT'])){
		$row['SCHEDULE_HEADCOUNT'] = $param['S_HEADCOUNT'];
	}//end if

	if(!empty($param['S_MAX'])){
		$row['SCHEDULE_MAX']	= $param['S_MAX'];
	}//end if

	if(!empty($param['S_MINI'])){
		$row['SCHEDULE_MINI']	= $param['S_MINI'];
	}//end if

	if(!empty($param['S_THREE'])){
		$row['SCHEDULE_THREE'] 	= $param['S_THREE'];
	}//end if

	if(!empty($param['S_FIVE'])){
		$row['SCHEDULE_FIVE']		= $param['S_FIVE'];
	}//end if

	if(!empty($param['S_ODD'])){
		$row['SCHEDULE_ODD']		= $param['S_ODD'];
	}//end if



echo "<PRE>";
var_dump($row);
echo "</PRE>";

        // 行の挿入

        $tour = new Tour_Schedule();
        $key=$tour->insert($row);


echo "{$key}  が登録されました<P>";
echo "{$param['controller']}<P>";
//View 
        $view = new Smarty_View($this->module);
        $view->assign('title', 'ツアー登録日程完了');
        $view->assign('param', $param);
        $view->showPage('template.tpl','ScheduleComplete');

        //$this->_redirect("/{$this->module}/{$this->controller}");
    }


    /**
     * updateアクション
     */
    public function updateAction()
    {
        $param = Zend_Controller_Action::_getAllParams();
        // 指定したidの行を更新
        $mssg = new Messages();
        $row = array ('id'  => $param['id'],
                      'title'  => $param['title'],
                      'content'=> $param['content']
                      );
        $db = $mssg->getAdapter();
        $where = $db->quoteInto('id = ?', $param['id']);
        $key = $mssg->update($row, $where);

        $this->_redirect("/{$this->module}/{$this->controller}/index/key/{$key}");
    }

    /**
     * deleteアクション
     */
    public function deleteAction()
    {
        $param = Zend_Controller_Action::_getAllParams();
        // 指定したidの行を削除
        $mssg = new Messages();
        $db = $mssg->getAdapter();
        $where = $db->quoteInto('id = ?', $param['id']);
        $mssg->delete($where);

        $this->_redirect("/{$this->module}/{$this->controller}/");
    }

    /**
     * アクション名が見つからない
     */
    public function __call($methodName, $args)
    {
        header('HTTP/1.1 404 Not found');
	throw new Exception('例外です');
        $view = new My_View();
        $view->pageTitle = '404 Not found';
        $view->content = '指定ページが見つかりません';
        $view->showPage();
    }
}



